"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ArrayPattern = function ArrayPattern() {
  var _this = this;

  _classCallCheck(this, ArrayPattern);

  _defineProperty(this, "actions", void 0);

  _defineProperty(this, "removeAllActionIfDeleteAfterCreate", function () {
    if (_this.actions.length >= 2 && _this.actions[0].type === 'CREATE_ARRAY' && _this.actions.slice(-1)[0].type === 'DELETE_ARRAY') {
      _this.actions = [];
    }
  });

  _defineProperty(this, "removeAllUpdateBeforeDelete", function () {
    if (_this.actions.length >= 2 && _this.actions[0].type !== 'CREATE_ARRAY' && _this.actions.slice(-1)[0].type === 'DELETE_ARRAY') {
      _this.actions = _this.actions.slice(-1);
    }
  });

  _defineProperty(this, "mergeAllUpdate", function () {
    if (_this.actions.length >= 2 && _this.actions[0].type === 'UPDATE_ARRAY' && _this.actions.slice(-1)[0].type === 'UPDATE_ARRAY') {
      _this.actions = [_this.actions.reduce(function (result, action) {
        result.payload.value = _objectSpread({}, result.payload.value, action.payload.value);
        return result;
      })];
    }
  });

  _defineProperty(this, "mergeUpdateAndCreate", function () {
    if (_this.actions.length >= 2 && _this.actions[0].type === 'CREATE_ARRAY' && _this.actions.slice(-1)[0].type === 'UPDATE_ARRAY') {
      _this.actions = [_this.actions.reduce(function (result, action) {
        result.payload.value = _objectSpread({}, result.payload.value, action.payload.value);
        return result;
      })];
    }
  });

  _defineProperty(this, "addAction", function (action) {
    _this.actions.push(action);

    _this.mergeAction();
  });

  _defineProperty(this, "mergeAction", function () {
    _this.removeAllActionIfDeleteAfterCreate();

    _this.removeAllUpdateBeforeDelete();

    _this.mergeAllUpdate();

    _this.mergeUpdateAndCreate();

    return _this.actions;
  });

  _defineProperty(this, "getActions", function () {
    return _this.actions;
  });

  this.actions = [];
};

exports.default = ArrayPattern;