"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lodash = require("lodash");

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ConnectPattern = function ConnectPattern() {
  var _this = this;

  _classCallCheck(this, ConnectPattern);

  _defineProperty(this, "actions", void 0);

  _defineProperty(this, "addAction", function (action) {
    _this.actions.push(action);

    _this.mergeAction();
  });

  _defineProperty(this, "mergeConnectAndDisconnectAndDelete", function () {
    _this.actions = (0, _lodash.uniqBy)(_toConsumableArray(_this.actions).reverse(), function (action) {
      var _action$payload = action.payload,
          key = _action$payload.key,
          id = _action$payload.id,
          path = _action$payload.path,
          value = _action$payload.value;
      return "".concat(key, ".").concat(id, ".").concat(path, ".").concat(value.id);
    });
  });

  _defineProperty(this, "mergeAction", function () {
    _this.mergeConnectAndDisconnectAndDelete();

    return _this.actions;
  });

  _defineProperty(this, "getActions", function () {
    return _this.actions;
  });

  this.actions = [];
};

exports.default = ConnectPattern;