"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.findNode = findNode;
exports.isToList = isToList;
exports.default = void 0;

require("antd/lib/alert/style");

var _alert = _interopRequireDefault(require("antd/lib/alert"));

var React = _interopRequireWildcard(require("react"));

var _reactLoadable = _interopRequireDefault(require("react-loadable"));

var _lodash = require("lodash");

var _cannerRefId = _interopRequireDefault(require("canner-ref-id"));

var _cannerLayouts = _interopRequireDefault(require("canner-layouts"));

var _antd = require("antd");

var _cannerHelpers = require("canner-helpers");

var _hocs = _interopRequireDefault(require("../hocs"));

var _reactContentLoader = require("react-content-loader");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Generator =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Generator, _React$Component);

  function Generator(_props) {
    var _this;

    _classCallCheck(this, Generator);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Generator).call(this, _props));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "idNodeMap", {});

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "renderNode", function (node, props, index) {
      // take the node.component to render it, and give the component
      // some props it maybe needs such as renderChildren
      // eslint-disable-next-line no-unused-vars
      if (!node) {
        throw new Error("Unexpected Error: Want to render a undefined node with refId '".concat(props.refId.toString(), "'"));
      }

      var component = node.component,
          restNodeData = _objectWithoutProperties(node, ["component"]);

      var _this$props = _this.props,
          _this$props$routerPar = _this$props.routerParams,
          routerParams = _this$props$routerPar === void 0 ? {} : _this$props$routerPar,
          goTo = _this$props.goTo,
          routes = _this$props.routes,
          imageStorages = _this$props.imageStorages,
          fileStorages = _this$props.fileStorages,
          onDeploy = _this$props.onDeploy,
          removeOnDeploy = _this$props.removeOnDeploy,
          hideButtons = _this$props.hideButtons,
          schema = _this$props.schema;

      var renderChildren = function renderChildren(props) {
        return _this.renderChildren(node, props);
      };

      if (node.hidden || props.hidden) {
        return null;
      }

      if (component) {
        var contextValue = {
          renderChildren: renderChildren,
          routes: routes,
          refId: props.refId
        };
        return React.createElement("div", {
          "data-testid": node.path
        }, React.createElement(_cannerHelpers.Context.Provider, {
          key: restNodeData.keyName ? "".concat(props.refId.toString(), "/").concat(restNodeData.keyName) : index,
          value: contextValue
        }, React.createElement(node.component, _extends({
          hideButtons: hideButtons,
          routes: routes,
          imageStorage: (imageStorages || {})[routes[0]],
          fileStorage: (fileStorages || {})[routes[0]],
          renderChildren: function renderChildren(props) {
            return _this.renderChildren(node, props);
          },
          renderComponent: _this.renderComponent,
          routerParams: routerParams,
          onDeploy: onDeploy,
          removeOnDeploy: removeOnDeploy,
          schema: schema,
          goTo: goTo
        }, restNodeData, props))));
      }

      return null;
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "renderComponent", function (refId, props) {
      var cacheTree = _this.state.cacheTree;
      var componentPathArr = refId.getPathArr().filter(function (path) {
        return isNaN(Number(path));
      });
      var componentPath = componentPathArr.join('/');
      var node = _this.idNodeMap[componentPath];
      var entryKey = componentPathArr[0];

      if (!node) {
        var lastPath = componentPathArr.slice(1);

        if (lastPath.length === 0) {
          node = cacheTree[entryKey];
        } else {
          node = findNode(componentPathArr.slice(), cacheTree[entryKey]);
        }

        _this.idNodeMap[componentPath] = node;
      }

      if (!node) {
        throw new Error("Can't find the node at refId ".concat(refId.toString()));
      }

      return _this.renderNode(node, _objectSpread({
        refId: refId.remove(1),
        keyName: refId.getPathArr().slice(-1)[0]
      }, props), 0);
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "renderChildren", function (node, props) {
      // just get the props and call renderNode
      // this method is called by components themselves
      var children = node.children;

      if (children) {
        return children.map(function (child, index) {
          var childProps = typeof props === 'function' ? props(child) : props;
          var refId = childProps.refId;

          if ((0, _lodash.isUndefined)(refId)) {
            throw new Error("refId is required for renderChildren, please check node '".concat(node.keyName || '', "'"));
          }

          if (childProps.hidden) {
            return null;
          }

          if (childProps.mergeNode) {
            // mutate node
            childProps.mergeNode(node);
          }

          return _this.renderNode(child, childProps, index);
        });
      }

      return null;
    });

    var componentTree = _props.componentTree;
    _this.state = {
      cacheTree: genCacheTree(componentTree),
      error: null,
      errorInfo: {}
    };
    return _this;
  }

  _createClass(Generator, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props2 = this.props,
          componentTree = _this$props2.componentTree,
          routes = _this$props2.routes,
          goTo = _this$props2.goTo,
          defaultKey = _this$props2.defaultKey;
      var activeKey = routes[0];

      if (!activeKey) {
        activeKey = Object.keys(componentTree)[0];
        goTo({
          pathname: defaultKey || activeKey
        });
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (this.props.refresh && !(0, _lodash.isEqual)(prevProps.componentTree, this.props.componentTree)) {
        this.setState({
          cacheTree: genCacheTree(this.props.componentTree)
        });
      }

      if (isToList(prevProps, this.props)) {
        this.props.reset && this.props.reset();
      }
    }
  }, {
    key: "componentDidCatch",
    value: function componentDidCatch(error, errorInfo) {
      // Catch errors in any components below and re-render with error message
      this.setState({
        error: error,
        errorInfo: errorInfo
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$state = this.state,
          cacheTree = _this$state.cacheTree,
          error = _this$state.error,
          errorInfo = _this$state.errorInfo;
      var _this$props3 = this.props,
          routes = _this$props3.routes,
          routerParams = _this$props3.routerParams;

      if (error) {
        return errorInfo;
      }

      if (!routes[0] || !cacheTree[routes[0]]) {
        return null;
      }

      return React.createElement("div", null, this.renderNode(cacheTree[routes[0]], {
        refId: new _cannerRefId.default(''),
        routes: routes,
        routerParams: routerParams
      }, 0));
    }
  }]);

  return Generator;
}(React.Component);

exports.default = Generator;

_defineProperty(Generator, "defaultProps", {
  componentTree: {},
  layouts: {}
});

function defaultHoc(Component) {
  return Component;
}

function isComponent(node) {
  return node.nodeType && node.nodeType.startsWith('component');
}

function isLayout(node) {
  return node.nodeType && node.nodeType.startsWith('layout');
}

function isFieldset(node) {
  return node.packageName === '@canner/antd-object-fieldset';
}

function isPage(node) {
  return node.nodeType && node.nodeType.startsWith('page');
}

function isPageRoot(node) {
  return node.nodeType === 'page.page.default';
}

function inPage(node) {
  return node.pattern.startsWith('page');
}

function Loading(props) {
  if (props.error) {
    return React.createElement(_alert.default, {
      message: "Something went wrong.",
      description: props.error,
      type: "error",
      closable: true
    });
  } else {
    return React.createElement(_reactContentLoader.List, {
      style: {
        maxWidth: '600px'
      }
    });
  }
}

function createLoadableComponnet(node) {
  return (0, _reactLoadable.default)({
    loader: function loader() {
      return node.loader || Promise.reject("There is no loader in ".concat(node.path));
    },
    loading: Loading
  });
}

function generateComponent(node) {
  var component = node.component;

  if (isLayout(node)) {
    if (!node.component) {
      component = _cannerLayouts.default[node.ui];
    }

    return wrapByHOC(component, node.ui === 'condition' ? ['containerQuery', 'context'] : ['context']);
  }

  if (isComponent(node)) {
    if (isFieldset(node)) {
      component = function component() {
        return React.createElement(_cannerHelpers.Item, null);
      };
    } else {
      component = createLoadableComponnet(node);
    }

    return wrapByHOC(component, ['title', 'onDeploy', 'validation', 'deploy', 'request', 'relation', 'query', 'cache', 'route', 'id', 'context', 'errorCatch']);
  } else if (isPage(node)) {
    if (isPageRoot(node)) {
      component = function component() {
        return React.createElement(_cannerHelpers.Item, null);
      };
    } else if (inPage(node)) {
      component = createLoadableComponnet(node);
      return wrapByHOC(component, ['graphqlQuery']);
    } else {
      component = createLoadableComponnet(node);
      component = wrapByHOC(component, ['title', 'onDeploy', 'validation', 'deploy', 'request', 'relation', 'query', 'cache', 'route', 'id', 'context', 'errorCatch']);
    }
  }

  return component;
}

function wrapByHOC(component, hocNames) {
  // find hocs and wrap the component
  while (hocNames.length) {
    var hocName = hocNames.shift();
    var hoc = (0, _lodash.get)(_hocs.default, hocName, defaultHoc);
    component = hoc(component);
  }

  return component;
} // wrap the plugin with hoc if it has


function prerender(node) {
  // add a field `component` in every node.
  // it's a React Component with all hocs it needs in every node
  var copyNode = _objectSpread({}, node);

  var component = generateComponent(node);

  if (!component) {
    throw new Error("invalid node, name: ".concat(copyNode.keyName, ", nodeType: ").concat(copyNode.nodeType));
  }

  copyNode.component = component;

  if (copyNode.children) {
    copyNode.children = copyNode.children.map(function (child) {
      return prerender(child);
    });
  }

  return copyNode;
}

function genCacheTree(tree) {
  return (0, _lodash.mapValues)(tree, function (branch) {
    return prerender(branch);
  });
}

function findNode(pathArr, node) {
  if (isComponent(node) && node.keyName === pathArr[0]) {
    pathArr = pathArr.slice(1);

    if (!pathArr.length) {
      return node;
    }
  }

  if (node.children) {
    return node.children.map(function (child) {
      return findNode(pathArr, child);
    }).find(function (node) {
      return !!node;
    });
  }
}

function isToList(preProps, props) {
  var preRoutes = JSON.stringify(preProps.routes);
  var routes = JSON.stringify(props.routes);
  var preOperator = preProps.routerParams.operator;
  var operator = props.routerParams.operator;
  return preRoutes === routes && preOperator === 'create' && operator === 'update';
}