"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _context = require("../hocs/context");

var _reactApollo = require("react-apollo");

var _isEmpty = _interopRequireDefault(require("lodash/isEmpty"));

var _pluralize = _interopRequireDefault(require("pluralize"));

var _upperFirst = _interopRequireDefault(require("lodash/upperFirst"));

var _action = require("../action");

var _query = require("../query");

var _onDeployManager = require("../onDeployManager");

var _graphqlTag = _interopRequireDefault(require("graphql-tag"));

var _utils = require("../query/utils");

var _mapValues = _interopRequireDefault(require("lodash/mapValues"));

var _lodash = require("lodash");

var _log = _interopRequireDefault(require("../utils/log"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _templateObject7() {
  var data = _taggedTemplateLiteral(["", ""]);

  _templateObject7 = function _templateObject7() {
    return data;
  };

  return data;
}

function _templateObject6() {
  var data = _taggedTemplateLiteral(["", ""]);

  _templateObject6 = function _templateObject6() {
    return data;
  };

  return data;
}

function _templateObject5() {
  var data = _taggedTemplateLiteral(["", ""]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = _taggedTemplateLiteral(["", ""]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = _taggedTemplateLiteral(["", ""]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = _taggedTemplateLiteral(["", ""]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["", ""]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Provider =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(Provider, _React$PureComponent);

  function Provider(props) {
    var _this;

    _classCallCheck(this, Provider);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Provider).call(this, props));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "actionManager", void 0);

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "query", void 0);

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "observableQueryMap", void 0);

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onDeployManager", void 0);

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {
      dataChanged: {}
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "genQuery", function () {
      var schema = _this.props.schema;
      _this.query = new _query.Query({
        schema: schema
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "genObservableQueryMap", function () {
      var _this$props = _this.props,
          schema = _this$props.schema,
          routes = _this$props.routes,
          routerParams = _this$props.routerParams;
      _this.observableQueryMap = (0, _mapValues.default)(schema, function (v, key) {
        if (routes[0] === key) {
          return _this.getObservable({
            routes: routes,
            operator: routerParams.operator
          });
        }

        return _this.getObservable({
          routes: [key],
          operator: 'update'
        });
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "getObservable", function (_ref) {
      var routes = _ref.routes,
          operator = _ref.operator;
      var _this$props2 = _this.props,
          client = _this$props2.client,
          schema = _this$props2.schema;
      var key = routes[0];

      var variables = _this.query && _this.query.getVairables();

      var customizedGQL = routes.length === 1 && operator === 'update' && schema[key].graphql;
      var fetchPolicy = schema[key].fetchPolicy;
      var gqlStr = '';

      if (customizedGQL) {
        gqlStr = schema[key].graphql;
      } else {
        gqlStr = _this.query.toGQL(key);
      }

      return client.watchQuery({
        query: (0, _graphqlTag.default)(_templateObject(), gqlStr),
        variables: variables,
        fetchPolicy: routes.length > 1 && operator === 'update' ? fetchPolicy : 'cache-first'
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "updateDataChanged", function () {
      var dataDidChange = _this.props.dataDidChange;

      var actions = _this.actionManager.getActions();

      var dataChanged = (0, _lodash.groupBy)(actions, function (action) {
        return action.payload.key;
      });
      dataChanged = (0, _mapValues.default)(dataChanged, function (value) {
        if (value[0].type === 'UPDATE_OBJECT') {
          return true;
        }

        return value.map(function (v) {
          return v.payload.id;
        });
      });

      if (dataDidChange) {
        dataDidChange(dataChanged);
      }

      _this.setState({
        dataChanged: dataChanged
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "updateQuery", function (paths, args) {
      var _this$props3 = _this.props,
          routerParams = _this$props3.routerParams,
          schema = _this$props3.schema,
          routes = _this$props3.routes;

      var originVariables = _this.query.getVairables();

      _this.query.updateQueries(paths, 'args', args);

      var variables = _this.query.getVairables();

      var reWatchQuery = compareVariables(originVariables, variables);

      if (reWatchQuery) {
        _this.observableQueryMap[paths[0]] = _this.getObservable({
          routes: paths,
          operator: routerParams.operator
        });
        (0, _log.default)('updateQuery rewatch', variables, args);
        return Promise.resolve(reWatchQuery);
      } else {
        var refetch = routes.length > 1 && schema[paths[0]] && schema[paths[0]].refetch;
        (0, _log.default)('updateQuery', variables, args);

        if (refetch) {
          return _this.observableQueryMap[paths[0]].refetch(variables).then(function () {
            return false;
          });
        }

        return _this.observableQueryMap[paths[0]].setVariables(variables).then(function () {
          return false;
        });
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "fetch", function (key) {
      var errorHandler = _this.props.errorHandler;
      var observabale = _this.observableQueryMap[key];
      var currentResult = observabale.currentResult();
      var loading = currentResult.loading,
          error = currentResult.error;

      if (loading) {
        return observabale.result().then(function (result) {
          (0, _log.default)('fetch', 'loading', key, result);
          return result.data;
        }).catch(function (e) {
          errorHandler && errorHandler(e);
        });
      } else if (error) {
        var lastResult = observabale.getLastResult();
        (0, _log.default)('fetch', 'error', key, lastResult);
        errorHandler && errorHandler(error);
        return Promise.resolve(lastResult.data);
      } else {
        (0, _log.default)('fetch', 'loaded', key, currentResult, _this.query.getVairables());
        return Promise.resolve(currentResult.data);
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "subscribe", function (key, callback) {
      var observableQuery = _this.observableQueryMap[key];
      return observableQuery.subscribe({
        next: function next() {
          var _observableQuery$curr = observableQuery.currentResult(),
              loading = _observableQuery$curr.loading,
              errors = _observableQuery$curr.errors,
              data = _observableQuery$curr.data;

          if (!loading && !errors && data && !(0, _isEmpty.default)(data)) {
            callback(data);
          }
        },
        error: function error() {// ignore the error here since in fetch method, the error should be handled
        }
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "executeOnDeploy", function (key, value) {
      return _this.onDeployManager.execute({
        key: key,
        value: value
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "deploy", function (key, id) {
      var _this$props4 = _this.props,
          client = _this$props4.client,
          afterDeploy = _this$props4.afterDeploy,
          schema = _this$props4.schema,
          errorHandler = _this$props4.errorHandler,
          routes = _this$props4.routes,
          rootKey = _this$props4.rootKey,
          routerParams = _this$props4.routerParams;

      var actions = _this.actionManager.getActions(key, id);

      if (!actions || !actions.length) {
        return Promise.resolve();
      }

      actions = removeIdInCreateArray(actions);
      var mutation = (0, _utils.objectToQueries)((0, _action.actionToMutation)(actions[0]), false);
      var variables = (0, _action.actionsToVariables)(actions, schema);

      var queryVariables = _this.query.getVairables();

      var query = null;

      if (routes.length === 1 && routerParams.operator === 'update' && schema[rootKey].graphql) {
        query = (0, _graphqlTag.default)(_templateObject2(), schema[rootKey].graphql);
      } else {
        query = (0, _graphqlTag.default)(_templateObject3(), _this.query.toGQL(actions[0].payload.key));
      }

      var cachedData = client.readQuery({
        query: query,
        variables: queryVariables
      });
      var mutatedData = cachedData[key];

      var _this$executeOnDeploy = _this.executeOnDeploy(key, mutatedData),
          error = _this$executeOnDeploy.error;

      if (error) {
        errorHandler && errorHandler(new Error('Invalid field'));
        return Promise.reject(error);
      }

      return client.mutate({
        mutation: (0, _graphqlTag.default)(_templateObject4(), mutation),
        variables: variables
      }).then(function (result) {
        if (actions[0].type === 'CREATE_ARRAY') {
          _this.updateID({
            action: actions[0],
            result: result
          });

          client.resetStore();
        }

        (0, _log.default)('deploy', key, {
          id: id,
          result: result,
          mutation: mutation,
          variables: variables
        });

        _this.actionManager.removeActions(key, id);

        return result.data;
      }).then(function (result) {
        _this.updateDataChanged();

        afterDeploy && afterDeploy({
          key: key,
          id: id || '',
          result: result,
          actions: actions
        });
        return result;
      }).catch(function (e) {
        errorHandler && errorHandler(e);
        (0, _log.default)('deploy', e, key, {
          id: id,
          mutation: mutation,
          variables: variables
        }); // to hocs

        throw e;
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "reset", function (key, id) {
      var rootKey = _this.props.rootKey;

      if (_this.actionManager.getActions(key, id).length === 0) {
        return Promise.resolve();
      }

      _this.actionManager.removeActions(key, id);

      _this.updateDataChanged();

      var variables = _this.query.getVairables();

      if (_this.observableQueryMap[key || rootKey]) {
        return _this.observableQueryMap[key || rootKey].refetch(variables);
      }

      return Promise.resolve();
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "request", function (action) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {
        write: true
      };
      var _options$write = options.write,
          write = _options$write === void 0 ? true : _options$write;
      var actions = [].concat(action);

      if (actions.length === 0) {
        return Promise.resolve();
      }

      actions.forEach(function (ac) {
        return _this.actionManager.addAction(ac);
      });

      _this.updateDataChanged();

      if (write) {
        var _this$updateCachedDat = _this.updateCachedData(actions),
            _data = _this$updateCachedDat.data,
            mutatedData = _this$updateCachedDat.mutatedData;

        (0, _log.default)('request', action, _data, mutatedData);
      }

      return Promise.resolve();
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "updateCachedData", function (actions) {
      var _this$props5 = _this.props,
          client = _this$props5.client,
          schema = _this$props5.schema,
          routes = _this$props5.routes,
          rootKey = _this$props5.rootKey,
          routerParams = _this$props5.routerParams;

      var variables = _this.query.getVairables();

      var query = null;

      if (routes.length === 1 && routerParams.operator === 'update' && schema[rootKey].graphql) {
        query = (0, _graphqlTag.default)(_templateObject5(), schema[rootKey].graphql);
      } else {
        query = (0, _graphqlTag.default)(_templateObject6(), _this.query.toGQL(actions[0].payload.key));
      }

      var data = client.readQuery({
        query: query,
        variables: variables
      });
      var mutatedData = actions.reduce(function (result, ac) {
        return (0, _action.mutate)(result, ac);
      }, data);
      client.writeQuery({
        query: query,
        variables: variables,
        data: mutatedData
      });
      return {
        data: data,
        mutatedData: mutatedData
      };
    });

    _this.actionManager = new _action.ActionManager();

    _this.genQuery();

    _this.genObservableQueryMap();

    _this.onDeployManager = new _onDeployManager.OnDeployManager();
    return _this;
  }

  _createClass(Provider, [{
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      var rootKey = nextProps.rootKey,
          routes = nextProps.routes,
          schema = nextProps.schema,
          routerParams = nextProps.routerParams;
      var customizedGQL = schema[rootKey] && schema[rootKey].graphql;

      if (customizedGQL) {
        this.observableQueryMap[rootKey] = this.getObservable({
          routes: routes,
          operator: routerParams.operator
        });
      }
    }
  }, {
    key: "updateID",
    value: function updateID(_ref2) {
      var action = _ref2.action,
          result = _ref2.result;
      var client = this.props.client;
      var originId = action.payload.id;
      var key = action.payload.key;
      var resultKey = "create".concat((0, _upperFirst.default)(_pluralize.default.singular(key)));
      var newId = result.data[resultKey].id;
      var variables = this.query.getVairables();
      var query = (0, _graphqlTag.default)(_templateObject7(), this.query.toGQL(key));
      var data = client.readQuery({
        query: query,
        variables: variables
      });
      data[key].edges.map(function (edge) {
        if (edge.cursor === originId) {
          edge.cursor = newId;
          edge.node.id = newId;
        }

        return edge;
      });
      client.writeQuery({
        query: query,
        variables: variables,
        data: data
      });
    }
  }, {
    key: "render",
    value: function render() {
      var client = this.props.client;
      return React.createElement(_reactApollo.ApolloProvider, {
        client: client
      }, React.createElement(_context.HOCContext.Provider, {
        value: {
          request: this.request,
          deploy: this.deploy,
          fetch: this.fetch,
          reset: this.reset,
          updateQuery: this.updateQuery,
          subscribe: this.subscribe,
          query: this.query,
          onDeploy: this.onDeployManager.registerCallback,
          removeOnDeploy: this.onDeployManager.unregisterCallback,
          dataChanged: this.state.dataChanged
        }
      }, React.cloneElement(this.props.children, {
        request: this.request,
        deploy: this.deploy,
        fetch: this.fetch,
        reset: this.reset,
        updateQuery: this.updateQuery,
        subscribe: this.subscribe,
        query: this.query,
        onDeploy: this.onDeployManager.registerCallback,
        removeOnDeploy: this.onDeployManager.unregisterCallback
      })));
    }
  }]);

  return Provider;
}(React.PureComponent);

exports.default = Provider;

function removeIdInCreateArray(actions) {
  return actions.map(function (action) {
    if (action.type === 'CREATE_ARRAY') {
      var newAction = JSON.parse(JSON.stringify(action));
      delete newAction.payload.value.id;
      delete newAction.payload.value.__typename;
      return newAction;
    }

    return action;
  });
}

function compareVariables(originVariables, variables) {
  var originArr = Object.keys(originVariables).filter(function (key) {
    return originVariables[key];
  });
  var varArr = Object.keys(variables).filter(function (key) {
    return variables[key];
  });
  var less = (0, _lodash.difference)(originArr, varArr);
  var more = (0, _lodash.difference)(varArr, originArr);

  if (less.length === 0 && more.length === 0) {
    return false;
  }

  return true;
}