"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.genClient = genClient;
exports.default = void 0;

require("antd/lib/notification/style");

var _notification2 = _interopRequireDefault(require("antd/lib/notification"));

var React = _interopRequireWildcard(require("react"));

var _Provider = _interopRequireDefault(require("./Provider"));

var _Generator = _interopRequireDefault(require("./Generator"));

var _antd = require("antd");

var _cannerHelpers = require("canner-helpers");

var _cannerCompiler = require("canner-compiler");

var _cannerGraphqlInterface = require("canner-graphql-interface");

var _lodash = require("lodash");

var _en = _interopRequireDefault(require("react-intl/locale-data/en"));

var _zh = _interopRequireDefault(require("react-intl/locale-data/zh"));

var _reactIntl = require("react-intl");

var _locale = _interopRequireDefault(require("./locale"));

var _antdLocales = _interopRequireDefault(require("@canner/antd-locales"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

(0, _reactIntl.addLocaleData)(_toConsumableArray(_en.default).concat(_toConsumableArray(_zh.default))); // type

var CannerCMS =
/*#__PURE__*/
function (_React$Component) {
  _inherits(CannerCMS, _React$Component);

  function CannerCMS(props) {
    var _this;

    _classCallCheck(this, CannerCMS);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(CannerCMS).call(this, props));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "imageServiceConfigs", void 0);

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "client", void 0);

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "provider", void 0);

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "componentTree", void 0);

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "schema", void 0);

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "dataDidChange", function (dataChanged) {
      var dataDidChange = _this.props.dataDidChange;

      if (dataDidChange) {
        dataDidChange(dataChanged);
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "deploy", function (key, id) {
      if (_this.provider) {
        return _this.provider.deploy(key, id);
      }

      return Promise.resolve();
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "reset", function (key, id) {
      if (_this.provider) {
        return _this.provider.reset(key, id);
      }

      return Promise.resolve();
    });

    var _props$schema = props.schema,
        schema = _props$schema.schema,
        visitors = _props$schema.visitors,
        pageSchema = _props$schema.pageSchema;

    var uiSchema = _objectSpread({}, pageSchema, (0, _lodash.pickBy)(schema, function (v) {
      return !v.defOnly;
    }));

    _this.componentTree = compile(uiSchema, visitors);
    _this.schema = Object.keys(schema).reduce(function (result, key) {
      var v = _objectSpread({}, schema[key]);

      if (v.type === 'array') {
        // v.items = v.items.items;
        v.items.id = {
          type: 'id'
        };
      }

      result[key] = v;
      return result;
    }, {});
    _this.client = genClient(_objectSpread({}, props.schema, {
      schema: schema
    }));
    return _this;
  }

  _createClass(CannerCMS, [{
    key: "componentDidCatch",
    value: function componentDidCatch(error) {
      var errorHandler = this.props.errorHandler;
      errorHandler && errorHandler(error);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          baseUrl = _this$props.baseUrl,
          routes = _this$props.routes,
          routerParams = _this$props.routerParams,
          goTo = _this$props.goTo,
          afterDeploy = _this$props.afterDeploy,
          _this$props$intl = _this$props.intl,
          intl = _this$props$intl === void 0 ? {} : _this$props$intl,
          hideButtons = _this$props.hideButtons,
          errorHandler = _this$props.errorHandler,
          _this$props$schema = _this$props.schema,
          imageStorages = _this$props$schema.imageStorages,
          fileStorages = _this$props$schema.fileStorages,
          _this$props$schema$di = _this$props$schema.dict,
          dict = _this$props$schema$di === void 0 ? {} : _this$props$schema$di,
          defaultKey = _this$props.defaultKey;
      var currentLocale = intl.locale || 'en';
      return React.createElement(_reactIntl.IntlProvider, {
        locale: currentLocale,
        key: currentLocale,
        defaultLocale: intl.defaultLocale || currentLocale,
        messages: _objectSpread({}, _antdLocales.default[currentLocale] || {}, _locale.default[currentLocale] || {}, dict[currentLocale] || {}, (intl.messages || {})[currentLocale] || {})
      }, React.createElement(_Provider.default, {
        ref: function ref(provider) {
          return _this2.provider = provider;
        },
        client: this.client,
        schema: this.schema,
        dataDidChange: this.dataDidChange,
        afterDeploy: afterDeploy,
        rootKey: routes[0],
        routes: routes,
        routerParams: routerParams || {},
        errorHandler: errorHandler || defaultErrorHandler
      }, React.createElement(_Generator.default, {
        imageStorages: imageStorages,
        fileStorages: fileStorages,
        schema: this.schema,
        componentTree: this.componentTree || {},
        goTo: goTo,
        baseUrl: baseUrl,
        routes: routes,
        routerParams: routerParams || {},
        hideButtons: hideButtons,
        defaultKey: defaultKey
      })));
    }
  }]);

  return CannerCMS;
}(React.Component);

_defineProperty(CannerCMS, "defaultProps", {
  schema: {
    schema: {}
  },
  dataDidChange: function dataDidChange() {},
  afterDeploy: function afterDeploy() {},
  baseUrl: '/',
  intl: {
    locale: 'en',
    defaultLocale: 'en',
    messages: {
      'en': {}
    }
  },
  routerParams: {},
  routes: []
});

function compile(schema, visitors) {
  var parser = new _cannerCompiler.Parser();
  var tree = parser.parse(schema);
  var traverser = new _cannerCompiler.Traverser(tree);
  visitors.forEach(function (visitor) {
    traverser.addVisitor(visitor);
  });
  var componentTree = traverser.traverse();
  return componentTree;
}

function genClient(schema) {
  var resolvers = schema.resolvers,
      connector = schema.connector,
      graphqlClient = schema.graphqlClient;
  var options = {
    schema: schema.schema
  };

  if (connector) {
    if ((0, _lodash.isPlainObject)(connector)) {
      if (!(0, _lodash.isEmpty)(connector)) {
        options.connectors = connector;
      }
    } else {
      options.connector = connector;
    }
  }

  if (graphqlClient) {
    if ((0, _lodash.isPlainObject)(graphqlClient)) {
      if (!(0, _lodash.isEmpty)(connector)) {
        options.graphqlClients = graphqlClient;
      }
    } else {
      options.graphqlClient = graphqlClient;
    }
  }

  if ((0, _lodash.isEmpty)(connector) && (0, _lodash.isEmpty)(graphqlClient)) {
    options.connector = new _cannerGraphqlInterface.MemoryConnector({
      defaultData: (0, _cannerHelpers.createFakeData)(schema.schema, 10)
    });
  }

  if (!(0, _lodash.isEmpty)(resolvers)) {
    options.resolvers = resolvers;
  }

  return (0, _cannerGraphqlInterface.createClient)(options);
}

function defaultErrorHandler(e) {
  return _notification2.default.error({
    message: e.message,
    placement: 'bottomRight'
  });
}

var _default = CannerCMS;
exports.default = _default;