"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("antd/lib/modal/style");

var _modal = _interopRequireDefault(require("antd/lib/modal"));

require("antd/lib/button/style");

var _button = _interopRequireDefault(require("antd/lib/button"));

require("antd/lib/select/style");

var _select = _interopRequireDefault(require("antd/lib/select"));

require("antd/lib/radio/style");

var _radio = _interopRequireDefault(require("antd/lib/radio"));

require("antd/lib/form/style");

var _form = _interopRequireDefault(require("antd/lib/form"));

var _react = _interopRequireDefault(require("react"));

var _antd = require("antd");

var _get = _interopRequireDefault(require("lodash/get"));

var _reactApollo = require("react-apollo");

var _reactIntl = require("react-intl");

var _graphqlTag = _interopRequireDefault(require("graphql-tag"));

var _dec, _class;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _templateObject() {
  var data = _taggedTemplateLiteral(["", ""]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var FormItem = _form.default.Item;
var RadioGroup = _radio.default.Group;
var Option = _select.default.Option;
var ALL = 'ALL';
var THIS_PAGE = 'THIS_PAGE';
var SELECTED = 'SElECTED';
var DOWNLOAD = 'DOWNLOAD'; // $FlowFixMe

var ExportModal = (_dec = _form.default.create(), (0, _reactIntl.injectIntl)(_class = (0, _reactApollo.withApollo)(_class = _dec(_class =
/*#__PURE__*/
function (_React$Component) {
  _inherits(ExportModal, _React$Component);

  function ExportModal() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, ExportModal);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(ExportModal)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {
      downloading: false
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleSubmit", function (e) {
      e.preventDefault();
      var _this$props = _this.props,
          form = _this$props.form,
          value = _this$props.value,
          selectedValue = _this$props.selectedValue,
          fileName = _this$props.fileName,
          triggerModal = _this$props.triggerModal,
          fields = _this$props.fields,
          client = _this$props.client,
          query = _this$props.query,
          keyName = _this$props.keyName;
      form.validateFields(function (err, values) {
        if (!err) {
          var exportData = values.exportData,
              exportFieldKeys = values.exportFieldKeys,
              exportWay = values.exportWay;
          var getData = Promise.resolve([]);

          if (exportData === ALL) {
            // have to fetch data without pagination data
            var queries = query.getQueries([keyName]).args;
            var variables = query.getVairables();
            delete variables[queries.first.substr(1)];
            delete variables[queries.after.substr(1)];
            delete variables[queries.last.substr(1)];
            delete variables[queries.before.substr(1)];
            getData = client.query({
              query: (0, _graphqlTag.default)(_templateObject(), query.toGQL(keyName)),
              // remove pagination field
              variables: variables
            }).then(function (result) {
              return result.data[keyName].edges.map(function (edge) {
                return edge.node;
              });
            });
          } else if (exportData === THIS_PAGE) {
            getData = Promise.resolve(value);
          } else if (exportData === SELECTED) {
            getData = Promise.resolve(selectedValue);
          }

          var fieldsData = fields.filter(function (field) {
            return exportFieldKeys.find(function (key) {
              return key === field.keyName;
            });
          });

          if (exportWay === DOWNLOAD) {
            _this.setState({
              downloading: true
            });

            getData.then(function (data) {
              var csv = genCSV(data, fieldsData);
              download(fileName, csv);
            }).then(function () {
              _this.setState({
                downloading: false
              }, triggerModal);
            });
          } else {// not support other exportWay for now
          }
        }
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleCancel", function () {
      _this.props.triggerModal();
    });

    return _this;
  }

  _createClass(ExportModal, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          selectedValue = _this$props2.selectedValue,
          visible = _this$props2.visible,
          fields = _this$props2.fields,
          getFieldDecorator = _this$props2.form.getFieldDecorator,
          title = _this$props2.title,
          intl = _this$props2.intl;
      var downloading = this.state.downloading;
      var formItemLayout = {
        labelCol: {
          xs: {
            span: 24
          },
          sm: {
            span: 5
          }
        },
        wrapperCol: {
          xs: {
            span: 24
          },
          sm: {
            span: 12
          }
        }
      };
      return _react.default.createElement(_modal.default, {
        title: _react.default.createElement(_reactIntl.FormattedMessage, {
          id: "actions.export.modal.title"
        }),
        visible: visible,
        footer: null,
        closable: true,
        maskClosable: true,
        onCancel: this.handleCancel
      }, _react.default.createElement(_form.default, {
        onSubmit: this.handleSubmit
      }, _react.default.createElement(FormItem, _extends({}, formItemLayout, {
        label: _react.default.createElement(_reactIntl.FormattedMessage, {
          id: "actions.export.data.label"
        })
      }), getFieldDecorator('exportData', {
        initialValue: selectedValue.length ? 'SELECTED' : 'ALL'
      })(_react.default.createElement(RadioGroup, null, _react.default.createElement(_radio.default, {
        value: ALL,
        "data-testid": "actions-export-data-all"
      }, _react.default.createElement(_reactIntl.FormattedMessage, {
        id: "actions.export.data.all"
      }), title), _react.default.createElement(_radio.default, {
        value: THIS_PAGE,
        "data-testid": "actions-export-data-this-page"
      }, _react.default.createElement(_reactIntl.FormattedMessage, {
        id: "actions.export.data.thisPage"
      })), _react.default.createElement(_radio.default, {
        value: "SELECTED",
        disabled: !selectedValue.length,
        "data-testid": "actions-export-data-selected"
      }, _react.default.createElement(_reactIntl.FormattedMessage, {
        id: "actions.export.data.selected",
        values: {
          length: selectedValue.length,
          title: title
        }
      }))))), _react.default.createElement(FormItem, _extends({}, formItemLayout, {
        label: _react.default.createElement(_reactIntl.FormattedMessage, {
          id: "actions.export.way.label"
        })
      }), getFieldDecorator('exportWay', {
        initialValue: DOWNLOAD
      })(_react.default.createElement(RadioGroup, {
        disabled: true
      }, _react.default.createElement(_radio.default, {
        value: DOWNLOAD,
        "data-testid": "actions-export-way-csv"
      }, _react.default.createElement(_reactIntl.FormattedMessage, {
        id: "actions.export.way.csv"
      }))))), _react.default.createElement(FormItem, _extends({}, formItemLayout, {
        label: _react.default.createElement(_reactIntl.FormattedMessage, {
          id: "actions.export.fields.label"
        })
      }), getFieldDecorator('exportFieldKeys', {
        initialValue: fields.map(function (field) {
          return field.keyName;
        })
      })(_react.default.createElement(_select.default, {
        mode: "multiple",
        placeholder: intl.formatMessage({
          id: "actions.export.fields.placeholder"
        }),
        "data-testid": "actions-export-fields-select"
      }, fields.map(function (field, index) {
        return _react.default.createElement(Option, {
          "data-testid": "actions-export-fields-option-".concat(index),
          value: field.keyName,
          key: field.keyName
        }, field.title || field.keyName);
      })))), _react.default.createElement(FormItem, {
        wrapperCol: {
          span: 12,
          offset: 5
        }
      }, _react.default.createElement(_button.default, {
        "data-testid": "actions-export-cancel-button",
        htmlType: "button",
        onClick: this.handleCancel
      }, _react.default.createElement(_reactIntl.FormattedMessage, {
        id: "actions.export.modal.cancelButton"
      })), _react.default.createElement(_button.default, {
        "data-testid": "actions-export-confirm-button",
        loading: downloading,
        type: "primary",
        htmlType: "submit",
        style: {
          marginLeft: 24
        }
      }, _react.default.createElement(_reactIntl.FormattedMessage, {
        id: "actions.export.modal.confirmButton"
      })))));
    }
  }]);

  return ExportModal;
}(_react.default.Component)) || _class) || _class) || _class);
exports.default = ExportModal;

function genCSV(data, fields) {
  var fieldNames = fields.map(function (field) {
    return field.title || field.keyName;
  });
  var rows = [fieldNames];
  data.forEach(function (datum) {
    var values = [];
    fields.forEach(function (field) {
      var value = (0, _get.default)(datum, field.keyName);

      if (field.render) {
        value = field.render(value);
      }

      if (Array.isArray(value)) {
        value = value.join(';');
      }

      values.push(value);
    });
    rows.push(values);
  });
  var csvContent = 'data:text/csv;charset=utf-8,';
  rows.forEach(function (rowArray) {
    var row = rowArray.join(',');
    csvContent += "".concat(row, "\r\n");
  });
  return csvContent;
}

function download(fileName, csvContent) {
  var encodedUri = encodeURI(csvContent);
  var link = document.createElement('a');
  link.setAttribute('href', encodedUri);
  link.setAttribute('download', "".concat(fileName, ".csv"));
  link.innerHTML = '';
  document.body && document.body.appendChild(link); // Required for FF

  link.click();
}