"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("antd/lib/dropdown/style");

var _dropdown = _interopRequireDefault(require("antd/lib/dropdown"));

require("antd/lib/button/style");

var _button = _interopRequireDefault(require("antd/lib/button"));

require("antd/lib/icon/style");

var _icon = _interopRequireDefault(require("antd/lib/icon"));

require("antd/lib/menu/style");

var _menu = _interopRequireDefault(require("antd/lib/menu"));

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _reactIntl = require("react-intl");

var _exportModal = _interopRequireDefault(require("./exportModal"));

var _importModal = _interopRequireDefault(require("./importModal"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Actions =
/*#__PURE__*/
function (_Component) {
  _inherits(Actions, _Component);

  function Actions() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Actions);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Actions)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {
      exportModalVisible: false,
      importModalVisible: false
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "triggerExportModal", function () {
      _this.setState({
        exportModalVisible: !_this.state.exportModalVisible
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "triggerImportModal", function () {
      _this.setState({
        importModalVisible: !_this.state.importModalVisible
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "addFilter", function (e) {
      var _this$props = _this.props,
          displayedFilters = _this$props.displayedFilters,
          addFilter = _this$props.addFilter;
      var index = Number(e.key);

      if (displayedFilters.indexOf(index) === -1) {
        addFilter(index);
      }
    });

    return _this;
  }

  _createClass(Actions, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          filters = _this$props2.filters,
          value = _this$props2.value,
          selectedValue = _this$props2.selectedValue,
          query = _this$props2.query,
          keyName = _this$props2.keyName,
          items = _this$props2.items,
          filter = _this$props2.filter,
          request = _this$props2.request,
          deploy = _this$props2.deploy;
      var exp = this.props.export || {};
      var imp = this.props.import || {};
      var exportFields = exp.fields || Object.keys(items).map(function (keyName) {
        return items[keyName];
      });
      var importFields = exp.fields || Object.keys(items).map(function (keyName) {
        return items[keyName];
      }); // in csv format, it's difficult to write array or object type

      importFields = importFields.filter(function (item) {
        return ['string', 'number', 'boolean'].indexOf(item.type) >= 0;
      });
      var _this$state = this.state,
          exportModalVisible = _this$state.exportModalVisible,
          importModalVisible = _this$state.importModalVisible;

      var menu = _react.default.createElement(_menu.default, {
        onClick: this.addFilter
      }, filters.map(function (filter, index) {
        return _react.default.createElement(_menu.default.Item, {
          key: index,
          "data-testid": "actions-filter-dropdown-menu-".concat(index)
        }, filter.label);
      }));

      return _react.default.createElement(_react.default.Fragment, null, _react.default.createElement(_button.default.Group, null, this.props.export && _react.default.createElement(_button.default, {
        onClick: this.triggerExportModal,
        "data-testid": "actions-export-button"
      }, _react.default.createElement(_icon.default, {
        type: "download"
      }), _react.default.createElement(_reactIntl.FormattedMessage, {
        id: "query.actions.export"
      })), this.props.import && _react.default.createElement(_button.default, {
        onClick: this.triggerImportModal,
        "data-testid": "actions-import-button"
      }, _react.default.createElement(_icon.default, {
        type: "upload"
      }), _react.default.createElement(_reactIntl.FormattedMessage, {
        id: "query.actions.import"
      })), filter && _react.default.createElement(_dropdown.default, {
        overlay: menu,
        "data-testid": "actions-filter-dropdown"
      }, _react.default.createElement(_button.default, {
        "data-testid": "actions-filter-button"
      }, _react.default.createElement(_icon.default, {
        type: "filter"
      }), _react.default.createElement(_reactIntl.FormattedMessage, {
        id: "query.actions.filter"
      })))), _react.default.createElement(_exportModal.default, {
        visible: exportModalVisible,
        triggerModal: this.triggerExportModal,
        title: exp.title || '',
        value: value || [],
        selectedValue: selectedValue || [],
        fields: exportFields || [],
        fileName: exp.filename || exp.title || 'export',
        query: query,
        keyName: keyName
      }), _react.default.createElement(_importModal.default, {
        visible: importModalVisible,
        triggerModal: this.triggerImportModal,
        title: imp.title || '',
        request: request,
        deploy: deploy,
        fields: importFields || [],
        fileName: imp.filename || imp.title || 'import',
        query: query,
        items: items,
        keyName: keyName
      }));
    }
  }]);

  return Actions;
}(_react.Component);

exports.default = Actions;