"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.flattenItems = flattenItems;

var _lodash = require("lodash");

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function flattenItems(items) {
  var fields = [];

  function loop(item) {
    var keyName = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';

    if (item.keyName) {
      keyName = "".concat(keyName).concat(keyName ? '.' : '').concat(item.keyName);
    }

    if (item.items && !item.items.type) {
      (0, _lodash.forEach)(item.items, function (item) {
        loop(item, keyName);
      });
    } else if (item.items && item.items.type && item.items.items) {
      (0, _lodash.forEach)(item.items.items, function (item) {
        loop(item, keyName);
      });
    } else {
      fields.push(_objectSpread({}, item, {
        keyName: keyName
      }));
    }
  }

  (0, _lodash.forEach)(items, function (item) {
    loop(item, '');
  });
  return fields;
}