"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("antd/lib/icon/style");

var _icon = _interopRequireDefault(require("antd/lib/icon"));

var React = _interopRequireWildcard(require("react"));

var _select = _interopRequireDefault(require("./select"));

var _number = _interopRequireDefault(require("./number"));

var _text = _interopRequireDefault(require("./text"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _antd = require("antd");

var _debounce = _interopRequireDefault(require("lodash/debounce"));

var _isEmpty = _interopRequireDefault(require("lodash/isEmpty"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  transition: 200ms;\n  maxWidth: 220px;\n  position: relative;\n  display: inline-block;\n  text-align: left;\n  margin: 8px 16px;\n  &:hover {\n    opacity: .8;\n  }\n  i.filter-cross {\n    transition: all 200ms;\n    left: 8px;\n    position: relative;\n    font-size: 18px;\n    cursor: pointer;\n  }\n  h5 {\n    margin-bottom: 0;\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var FilterWrapper = _styledComponents.default.div(_templateObject());

var FilterGroup =
/*#__PURE__*/
function (_React$Component) {
  _inherits(FilterGroup, _React$Component);

  function FilterGroup() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, FilterGroup);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(FilterGroup)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onChange", function (cond) {
      var _this$props = _this.props,
          where = _this$props.where,
          changeFilter = _this$props.changeFilter;

      if ((0, _isEmpty.default)(cond)) {
        changeFilter({});
      } else {
        Object.keys(cond).forEach(function (key) {
          var newCond = cond[key];

          if (newCond === undefined) {
            delete where[key];
          } else {
            where[key] = cond[key];
          }
        });
        changeFilter(where);
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "deleteFilter", function (index) {
      var _this$props2 = _this.props,
          deleteFilter = _this$props2.deleteFilter,
          filters = _this$props2.filters;
      var filter = filters[index];

      if (filter.type === 'select') {
        var allField = filter.options.reduce(function (result, option) {
          Object.keys(option.condition).forEach(function (key) {
            if (!(key in result)) {
              result[key] = undefined;
            }
          });
          return result;
        }, {});

        _this.onChange(allField);
      } else {
        _this.onChange(_defineProperty({}, filter.field, undefined));
      }

      deleteFilter(index);
    });

    return _this;
  }

  _createClass(FilterGroup, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props3 = this.props,
          _this$props3$filters = _this$props3.filters,
          filters = _this$props3$filters === void 0 ? [] : _this$props3$filters,
          displayedFilters = _this$props3.displayedFilters,
          where = _this$props3.where;

      if (!filters || !filters.length) {
        return null;
      }

      var debounceChange = (0, _debounce.default)(this.onChange, 500);

      var renderFilter = function renderFilter(filter, index) {
        switch (filter.type) {
          case 'select':
            return React.createElement(_select.default, {
              index: index,
              onChange: debounceChange,
              options: filter.options,
              where: where
            });

          case 'number':
            return React.createElement(_number.default, {
              index: index,
              onChange: debounceChange,
              name: filter.field,
              where: where
            });

          /*
          case 'dateRange':
            return <DateRangeFilter onChange={debounceChange} schema={{[filter.field]: filter}}/>
          */

          case 'text':
            return React.createElement(_text.default, {
              index: index,
              onChange: debounceChange,
              name: filter.field,
              where: where
            });

          default:
            return null;
        }
      };

      return React.createElement(React.Fragment, null, displayedFilters.map(function (index) {
        return React.createElement(FilterWrapper, {
          key: index
        }, React.createElement("h5", null, filters[index].label), renderFilter(filters[index], index), !filters[index].alwaysDisplay && React.createElement(_icon.default, {
          "data-testid": "filter-".concat(index, "-delete-icon"),
          className: "filter-cross",
          type: "close-circle",
          onClick: function onClick() {
            return _this2.deleteFilter(index);
          }
        }));
      }));
    }
  }]);

  return FilterGroup;
}(React.Component);

exports.default = FilterGroup;