"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("antd/lib/input/style");

var _input = _interopRequireDefault(require("antd/lib/input"));

require("antd/lib/select/style");

var _select = _interopRequireDefault(require("antd/lib/select"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _antd = require("antd");

var _isNaN = _interopRequireDefault(require("lodash/isNaN"));

var _isEmpty = _interopRequireDefault(require("lodash/isEmpty"));

var _reactIntl = require("react-intl");

var _class, _class2, _temp;

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Option = _select.default.Option;
var InputGroup = _input.default.Group;
var operators = [{
  symbol: '>',
  value: 'gt'
}, {
  symbol: '<',
  value: 'lt'
}, {
  symbol: '=',
  value: 'eq'
}, {
  symbol: '≥',
  value: 'gte'
}, {
  symbol: '≤',
  value: 'lte'
}];

var NumberRangeFilter = (0, _reactIntl.injectIntl)(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(NumberRangeFilter, _Component);

  function NumberRangeFilter(props) {
    var _this;

    _classCallCheck(this, NumberRangeFilter);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(NumberRangeFilter).call(this, props));
    _this.state = {
      input: '',
      lowInput: '',
      operator: 'gt'
    };
    _this.onInputLow = _this.onInputLow.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.onInput = _this.onInput.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.changeOperator = _this.changeOperator.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.onChange = _this.onChange.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    return _this;
  }

  _createClass(NumberRangeFilter, [{
    key: "onInputLow",
    value: function onInputLow(e) {
      var value = e.target.value;
      var reg = /^-?(0|[1-9][0-9]*)(\.[0-9]*)?$/;

      if (!(0, _isNaN.default)(value) && reg.test(value) || value === '' || value === '-') {
        this.setState({
          lowInput: value
        }, this.onChange);
      }
    }
  }, {
    key: "onInput",
    value: function onInput(e) {
      var value = e.target.value;
      var reg = /^-?(0|[1-9][0-9]*)(\.[0-9]*)?$/;

      if (!(0, _isNaN.default)(value) && reg.test(value) || value === '' || value === '-') {
        this.setState({
          input: value
        }, this.onChange);
      }
    }
  }, {
    key: "changeOperator",
    value: function changeOperator(val) {
      this.setState({
        operator: val
      }, this.onChange);
    }
  }, {
    key: "onChange",
    value: function onChange() {
      var _this$state = this.state,
          lowInput = _this$state.lowInput,
          input = _this$state.input,
          operator = _this$state.operator;
      var _this$props = this.props,
          name = _this$props.name,
          onChange = _this$props.onChange;

      if (operator === '$between') {
        onChange({
          name: {
            $gt: (0, _isEmpty.default)(lowInput) ? -Infinity : Number(lowInput),
            $lt: (0, _isEmpty.default)(input) ? Infinity : Number(input)
          }
        });
      } else {
        onChange((0, _isEmpty.default)(input) ? undefined : _defineProperty({}, name, _defineProperty({}, operator, Number(input))));
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          intl = _this$props2.intl,
          index = _this$props2.index;
      var _this$state2 = this.state,
          operator = _this$state2.operator,
          input = _this$state2.input;
      var placeholder = intl.formatMessage({
        id: 'query.numberRange.placeholder'
      });
      return _react.default.createElement(InputGroup, {
        compact: true
      }, _react.default.createElement(_select.default, {
        style: {
          width: 60
        },
        value: operator,
        onChange: this.changeOperator,
        "data-testid": "number-filter-".concat(index, "-select")
      }, operators.map(function (operator) {
        return _react.default.createElement(Option, {
          key: operator.value,
          value: operator.value
        }, operator.symbol);
      })), _react.default.createElement(_input.default, {
        style: {
          width: 120
        },
        "data-testid": "number-filter-".concat(index, "-input"),
        placeholder: placeholder,
        value: input,
        onChange: this.onInput
      }));
    }
  }]);

  return NumberRangeFilter;
}(_react.Component), _defineProperty(_class2, "propTypes", {
  onChange: _propTypes.default.func,
  name: _propTypes.default.string,
  label: _propTypes.default.string,
  intl: _propTypes.default.object,
  index: _propTypes.default.number
}), _temp)) || _class;

exports.default = NumberRangeFilter;