"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.parseOrder = parseOrder;
exports.parsePagination = parsePagination;
exports.parseWhere = parseWhere;
exports.processWhere = processWhere;
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _lodash = require("lodash");

var _toolbarlayout = _interopRequireDefault(require("./toolbarlayout"));

var _pagination = _interopRequireDefault(require("./pagination"));

var _sort = _interopRequireDefault(require("./sort"));

var _index = _interopRequireDefault(require("./filter/index"));

var _actions = _interopRequireDefault(require("./actions"));

var _isObject = _interopRequireDefault(require("lodash/isObject"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Toolbar =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(Toolbar, _React$PureComponent);

  function Toolbar(props) {
    var _this;

    _classCallCheck(this, Toolbar);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Toolbar).call(this, props));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "async", void 0);

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "changeOrder", function (_ref) {
      var orderField = _ref.orderField,
          orderType = _ref.orderType;
      var _this$props = _this.props,
          updateQuery = _this$props.updateQuery,
          refId = _this$props.refId,
          args = _this$props.args;

      if (_this.async) {
        if (orderField) {
          updateQuery(refId.getPathArr(), {
            first: 10,
            orderBy: "".concat(orderField, "_").concat(orderType),
            where: args.where
          });
        } else {
          updateQuery(refId.getPathArr(), {
            first: 10,
            where: args.where
          });
        }
      } else {
        if (orderField) {
          _this.setState({
            sort: {
              orderField: orderField,
              orderType: orderType
            }
          });
        } else {
          _this.setState({
            sort: {}
          });
        }
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "changeFilter", function (where) {
      var _this$props2 = _this.props,
          updateQuery = _this$props2.updateQuery,
          refId = _this$props2.refId,
          args = _this$props2.args,
          toolbar = _this$props2.toolbar;
      var permanentFilter = {};

      if (toolbar && toolbar.filter && toolbar.filter.permanentFilter) {
        permanentFilter = toolbar.filter.permanentFilter || {};
      }

      if (_this.async) {
        updateQuery(refId.getPathArr(), {
          first: 10,
          orderBy: args.orderBy,
          // $FlowFixMe
          where: _objectSpread({}, processWhere(where), permanentFilter)
        });
      } else {
        _this.setState({
          // $FlowFixMe
          filter: _objectSpread({}, where)
        });
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "changePage", function (page) {
      _this.setState({
        current: page
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "nextPage", function () {
      var _this$props3 = _this.props,
          updateQuery = _this$props3.updateQuery,
          args = _this$props3.args,
          refId = _this$props3.refId,
          keyName = _this$props3.keyName;
      var _this$state = _this.state,
          originRootValue = _this$state.originRootValue,
          pagination = _this$state.pagination;

      if ((0, _lodash.get)(originRootValue, [keyName, 'pageInfo', 'hasNextPage'])) {
        var after = originRootValue[keyName].edges.slice(-1)[0].cursor; // the last one

        updateQuery(refId.getPathArr(), _objectSpread({}, args, {
          first: pagination.first || 10,
          after: after,
          last: undefined,
          before: undefined
        }));
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "prevPage", function () {
      var _this$props4 = _this.props,
          updateQuery = _this$props4.updateQuery,
          args = _this$props4.args,
          refId = _this$props4.refId,
          keyName = _this$props4.keyName;
      var _this$state2 = _this.state,
          originRootValue = _this$state2.originRootValue,
          pagination = _this$state2.pagination;

      if ((0, _lodash.get)(originRootValue, [keyName, 'pageInfo', 'hasPreviousPage'])) {
        var before = (0, _lodash.get)(originRootValue, [keyName, 'edges', 0, 'cursor']); // the first one

        updateQuery(refId.getPathArr(), _objectSpread({}, args, {
          last: pagination.last || 10,
          before: before,
          after: undefined,
          first: undefined
        }));
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "changeSize", function (size) {
      var _this$props5 = _this.props,
          updateQuery = _this$props5.updateQuery,
          args = _this$props5.args,
          refId = _this$props5.refId;
      var pagination = parsePagination(args);

      if (pagination.last) {
        updateQuery(refId.getPathArr(), _objectSpread({}, args, {
          last: size
        }));
      } else {
        updateQuery(refId.getPathArr(), _objectSpread({}, args, {
          first: size
        }));
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "addFilter", function (index) {
      _this.setState({
        displayedFilterIndexs: _this.state.displayedFilterIndexs.concat(index)
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "deleteFilter", function (index) {
      _this.setState({
        displayedFilterIndexs: _this.state.displayedFilterIndexs.filter(function (i) {
          return i !== index;
        })
      });
    });

    var _args = props.args,
        _originRootValue = props.originRootValue;
    _this.async = props.toolbar && props.toolbar.async; // $FlowFixMe

    var _permanentFilter = props.toolbar && props.toolbar.filter && props.toolbar.filter.permanentFilter || {};

    _this.state = {
      originRootValue: _originRootValue,
      sort: parseOrder(_args.orderBy),
      filter: _objectSpread({}, parseWhere(_args.where || {}), parseWhere(_permanentFilter)),
      pagination: parsePagination(_args),
      current: 1,
      displayedFilterIndexs: []
    };
    return _this;
  }

  _createClass(Toolbar, [{
    key: "render",
    value: function render() {
      var _this$props6 = this.props,
          children = _this$props6.children,
          _this$props6$toolbar = _this$props6.toolbar,
          toolbar = _this$props6$toolbar === void 0 ? {} : _this$props6$toolbar,
          args = _this$props6.args,
          refId = _this$props6.refId,
          items = _this$props6.items,
          defaultValue = _this$props6.defaultValue,
          parseConnectionToNormal = _this$props6.parseConnectionToNormal,
          getValue = _this$props6.getValue,
          query = _this$props6.query,
          keyName = _this$props6.keyName,
          request = _this$props6.request,
          deploy = _this$props6.deploy;
      var _this$state3 = this.state,
          originRootValue = _this$state3.originRootValue,
          current = _this$state3.current,
          displayedFilterIndexs = _this$state3.displayedFilterIndexs;
      var sorter = toolbar.sorter,
          pagination = toolbar.pagination,
          filter = toolbar.filter,
          toolbarLayout = toolbar.toolbarLayout,
          actions = toolbar.actions;
      var ToolbarLayout = toolbarLayout && toolbarLayout.component ? toolbarLayout.component : _toolbarlayout.default;
      var SortComponent = sorter && sorter.component ? sorter.component : _sort.default;
      var FilterComponent = filter && filter.component ? filter.component : _index.default;
      var PaginationComponent = pagination && pagination.component ? pagination.component : _pagination.default;
      var ActionsComponent = actions && actions.component ? actions.component : _actions.default;

      var _parseOrder = parseOrder(args.orderBy),
          orderField = _parseOrder.orderField,
          orderType = _parseOrder.orderType;

      var where = parseWhere(args.where || {});

      var _parsePagination = parsePagination(args),
          first = _parsePagination.first,
          last = _parsePagination.last;

      var total = 0;
      var rootValue = parseConnectionToNormal(originRootValue);
      var value = getValue(originRootValue, refId.getPathArr());
      return React.createElement(ToolbarLayout, {
        Actions: actions && toolbar.async ? React.createElement(ActionsComponent, _extends({}, actions, {
          async: toolbar.async,
          filters: filter && filter.filters || [],
          displayedFilters: displayedFilterIndexs,
          addFilter: this.addFilter,
          query: query,
          keyName: keyName,
          value: rootValue[keyName],
          items: items.items,
          request: request,
          deploy: deploy
        })) : React.createElement("div", null),
        Sort: sorter && toolbar.async ? React.createElement(SortComponent, _extends({}, sorter, {
          async: toolbar.async,
          defaultField: sorter.defaultField,
          options: sorter.options || [],
          changeOrder: this.changeOrder,
          orderField: orderField,
          orderType: orderType,
          items: items
        })) : null,
        Pagination: pagination && toolbar.async ? React.createElement(PaginationComponent, _extends({}, pagination, {
          async: toolbar.async,
          hasNextPage: (0, _lodash.get)(value, ['pageInfo', 'hasNextPage']),
          hasPreviousPage: (0, _lodash.get)(value, ['pageInfo', 'hasPreviousPage']),
          nextPage: this.nextPage,
          prevPage: this.prevPage,
          changeSize: this.changeSize,
          size: first || last,
          current: current,
          changePage: this.changePage,
          total: total
        })) : null,
        Filter: filter && toolbar.async ? React.createElement(FilterComponent, _extends({
          async: toolbar.async
        }, filter, {
          displayedFilters: displayedFilterIndexs,
          items: items,
          where: where,
          changeFilter: this.changeFilter,
          deleteFilter: this.deleteFilter
        })) : null
      }, React.cloneElement(children, {
        rootValue: rootValue,
        value: value ? (0, _lodash.get)(value, 'edges', []).map(function (item) {
          return item.node;
        }) : defaultValue('array'),
        showPagination: toolbar && !toolbar.async
      }));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps) {
      var originRootValue = nextProps.originRootValue,
          args = nextProps.args,
          toolbar = nextProps.toolbar;

      if (toolbar && !toolbar.async) {
        return {
          originRootValue: originRootValue
        };
      } // $FlowFixMe


      var permanentFilter = toolbar.filter && toolbar.filter.permanentFilter || {};
      return {
        originRootValue: originRootValue,
        sort: parseOrder(args.orderBy),
        filter: _objectSpread({}, parseWhere(args.where || {}), parseWhere(permanentFilter)),
        pagination: parsePagination(args)
      };
    }
  }]);

  return Toolbar;
}(React.PureComponent);

exports.default = Toolbar;

function parseOrder(orderBy) {
  if (typeof orderBy === 'string') {
    var _orderBy$split = orderBy.split('_'),
        _orderBy$split2 = _slicedToArray(_orderBy$split, 2),
        orderField = _orderBy$split2[0],
        orderType = _orderBy$split2[1];

    if (orderType !== 'ASC' && orderType !== 'DESC') {
      return {
        orderField: orderField,
        orderType: 'ASC'
      };
    }

    return {
      orderField: orderField,
      orderType: orderType
    };
  }

  return {
    orderField: null,
    orderType: 'ASC'
  };
}

function parsePagination() {
  var args = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return {
    first: args.first,
    after: args.after,
    last: args.last,
    before: args.before
  };
}

function parseWhere(where) {
  return Object.keys(where).reduce(function (result, key) {
    var v = where[key];

    var type = _typeof(v);

    var _key$split = key.split('_'),
        _key$split2 = _slicedToArray(_key$split, 2),
        field = _key$split2[0],
        op = _key$split2[1];

    if (type === 'string') {
      result[field] = _defineProperty({}, op || 'eq', v);
    }

    if (type === 'boolean') {
      result[field] = _defineProperty({}, op || 'eq', v);
    }

    if (type === 'number') {
      result[field] = _defineProperty({}, op || 'eq', v);
    }

    if (type === 'object') {
      result[field] = parseWhere(v);
    }

    return result;
  }, {});
}

function processWhere(where) {
  return Object.keys(where).reduce(function (result, key) {
    var v = where[key];

    if (isEnd(v)) {
      var _parseOpAndValue = parseOpAndValue(v),
          op = _parseOpAndValue.op,
          value = _parseOpAndValue.value;

      result["".concat(key, "_").concat(op)] = value;
    } else {
      result[key] = processWhere(v);
    }

    return result;
  }, {});
}

function isEnd(v) {
  if (!(0, _isObject.default)(v)) {
    return false;
  }

  var keys = Object.keys(v);
  var value = v[keys[0]];
  return keys.length === 1 && ['lt', 'lte', 'gt', 'gte', 'eq', 'contains'].indexOf(keys[0]) !== -1 && (typeof value === 'string' || typeof value === 'boolean' || typeof value === 'number');
}

function parseOpAndValue(v) {
  var op = Object.keys(v)[0];
  var value = v[op];
  return {
    op: op,
    value: value
  };
}