"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = withCache;
exports.isRoutesEndAtMe = isRoutesEndAtMe;
exports.genSubscriberId = genSubscriberId;

var React = _interopRequireWildcard(require("react"));

var _action = require("../action");

var _route = require("./route");

var _lodash = require("lodash");

var _mapValues = _interopRequireDefault(require("lodash/mapValues"));

var _onDeployManager = require("../onDeployManager");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function withCache(Com, options) {
  var _ref = options || {},
      _ref$mutate = _ref.mutate,
      mutate = _ref$mutate === void 0 ? _action.mutate : _ref$mutate,
      _ref$ActionManager = _ref.ActionManager,
      ActionManager = _ref$ActionManager === void 0 ? _action.ActionManager : _ref$ActionManager;

  return (
    /*#__PURE__*/
    function (_React$Component) {
      _inherits(ComWithCache, _React$Component);

      function ComWithCache(props) {
        var _this;

        _classCallCheck(this, ComWithCache);

        _this = _possibleConstructorReturn(this, _getPrototypeOf(ComWithCache).call(this, props));

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "actionManager", void 0);

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onDeployManager", void 0);

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "subscribers", void 0);

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "subscribers", {});

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "subscription", void 0);

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "addSubscriber", function (key, id, callback) {
          var subscriber = {
            id: id,
            callback: callback
          };

          if (_this.subscribers[key]) {
            _this.subscribers[key].push(subscriber);
          } else {
            _this.subscribers[key] = [subscriber];
          }
        });

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "unsubscribe", function (key, subscriberId) {
          _this.subscribers[key] = _this.subscribers[key].filter(function (subscriber) {
            return subscriber.id !== subscriberId;
          });
        });

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "publish", function (key, id) {
          // $FlowFixMe
          if (!_this.actionManager) {
            return;
          }

          var data = _this.state[key];

          if (!data) {
            return;
          }

          var actions = _this.actionManager.getActions(key, id);

          var mutatedData = actions.reduce(function (result, action) {
            return mutate(result, action);
          }, data);
          (_this.subscribers[key] || []).forEach(function (subscribe) {
            subscribe.callback(mutatedData);
          });
        });

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "fetch", function (key) {
          // the data will be mutated by cached actions
          var fetch = _this.props.fetch;

          if (!_this.actionManager) {
            return fetch(key);
          }

          var actions = _this.actionManager.getActions(key);

          return fetch(key).then(function (data) {
            _this.setState(_defineProperty({}, key, data));

            _this._subscribe(key);

            return actions.reduce(function (result, action) {
              return mutate(result, action);
            }, data);
          });
        });

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "_subscribe", function (key) {
          var subscribe = _this.props.subscribe;
          _this.subscription = subscribe(key, function (data) {
            _this.setState(_defineProperty({}, key, data), function () {
              return _this.publish(key);
            });
          });
        });

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "_unsubscribe", function () {
          if (_this.subscription) {
            _this.subscription.unsubscribe();
          }
        });

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "request", function (action) {
          // use action manager cache the actions
          // update state.actions
          var request = _this.props.request;

          if (!_this.actionManager) {
            // $FlowFixMe
            return request(action);
          }

          var key, id;

          if ((0, _lodash.isArray)(action)) {
            // $FlowFixMe
            action.forEach(function (ac) {
              // $FlowFixMe
              _this.actionManager.addAction(ac);
            });
            key = action[0].payload.key;
            id = action[0].payload.id;
          } else {
            // $FlowFixMe
            _this.actionManager.addAction(action); // $FlowFixMe


            key = action.payload.key; // $FlowFixMe

            id = action.payload.id;
          }

          _this.updateDataChanged();

          _this.publish(key, id);

          return Promise.resolve();
        });

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onDeploy", function (key, callback) {
          var onDeploy = _this.props.onDeploy;

          if (!_this.onDeployManager) {
            return onDeploy(key, callback);
          }

          return _this.onDeployManager.registerCallback(key, callback);
        });

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "removeOnDeploy", function (key, callbackId) {
          var removeOnDeploy = _this.props.removeOnDeploy;

          if (!_this.onDeployManager) {
            return removeOnDeploy(key, callbackId);
          }

          return _this.onDeployManager.unregisterCallback(key, callbackId);
        });

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "_executeOnDeployCallback", function (key, value) {
          return _this.onDeployManager.execute({
            key: key,
            value: value
          });
        });

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "deploy", function (key, id) {
          // request cached actions
          var _this$props = _this.props,
              request = _this$props.request,
              deploy = _this$props.deploy,
              pattern = _this$props.pattern;

          if (!_this.actionManager) {
            return deploy(key, id);
          }

          var originData = _this.state[key];

          var actions = _this.actionManager.getActions(key, id);

          var mutatedData = actions.reduce(function (result, action) {
            return mutate(result, action);
          }, originData);

          var _this$_executeOnDeplo = _this._executeOnDeployCallback(key, mutatedData[key]),
              error = _this$_executeOnDeplo.error;

          if (error) {
            return Promise.reject();
          } // actions = actions.map(action => {
          //   const {key, value} = action.payload;
          //   hasError = hasError || error;
          //   action.payload.value = data;
          //   return action;
          // });
          // $FlowFixMe


          _this.actionManager.removeActions(key, id);

          _this.updateDataChanged(); // $FlowFixMe


          request(actions); // if this cache is on the first layer,
          // it should call the deploy after request

          if (pattern.split('.').length === 1) {
            return deploy(key, id);
          }

          return Promise.resolve();
        });

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "reset", function (key, id) {
          // remove sepicfic cached actions in actionManager
          var reset = _this.props.reset;

          if (!_this.actionManager) {
            return reset(key, id);
          }

          _this.actionManager.removeActions(key, id);

          _this.updateDataChanged();

          _this.publish(key, id);

          return Promise.resolve();
        });

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "subscribe", function (key, callback) {
          var subscribe = _this.props.subscribe;

          if (!_this.actionManager) {
            return subscribe(key, callback);
          }

          var id = genSubscriberId();

          _this.addSubscriber(key, id, callback);

          return {
            unsubscribe: function unsubscribe() {
              _this.unsubscribe(key, id);
            }
          };
        });

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "updateDataChanged", function () {
          if (!_this.actionManager) {
            return;
          }

          var actions = _this.actionManager.getActions();

          var dataChanged = (0, _lodash.groupBy)(actions, function (action) {
            return action.payload.key;
          });
          dataChanged = (0, _mapValues.default)(dataChanged, function (value) {
            if (value[0].type === 'UPDATE_OBJECT') {
              return true;
            }

            return value.map(function (v) {
              return v.payload.id;
            });
          });

          _this.setState({
            dataChanged: dataChanged
          });
        });

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "updateQuery", function (paths, args) {
          var updateQuery = _this.props.updateQuery;
          return updateQuery(paths, args).then(function (reWatch) {
            if (reWatch) {
              _this._unsubscribe();

              _this.fetch(paths[0]);
            }

            return reWatch;
          });
        });

        var _this$props2 = _this.props,
            routes = _this$props2.routes,
            cacheActions = _this$props2.cacheActions,
            _pattern = _this$props2.pattern,
            path = _this$props2.path;

        if (routes.length > 1 && isRoutesEndAtMe({
          routes: routes,
          pattern: _pattern,
          path: path
        }) || cacheActions) {
          _this.actionManager = new ActionManager();
          _this.onDeployManager = new _onDeployManager.OnDeployManager();
        }

        _this.state = {
          dataChanged: {}
        };
        return _this;
      }

      _createClass(ComWithCache, [{
        key: "render",
        value: function render() {
          return React.createElement(Com, _extends({}, this.props, {
            fetch: this.fetch,
            request: this.request,
            deploy: this.deploy,
            reset: this.reset,
            subscribe: this.subscribe,
            updateQuery: this.updateQuery,
            onDeploy: this.onDeploy,
            removeOnDeploy: this.removeOnDeploy,
            dataChanged: this.state.dataChanged
          }));
        }
      }]);

      return ComWithCache;
    }(React.Component)
  );
}

function isRoutesEndAtMe(_ref2) {
  var routes = _ref2.routes,
      path = _ref2.path,
      pattern = _ref2.pattern;
  var paths = (0, _route.genPaths)(path, pattern);
  return paths.length === routes.length && (0, _route.isCompleteContain)(paths, routes);
}

function genSubscriberId() {
  return Math.random().toString(36).substr(2, 7);
}