"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = withContainerRouter;
exports.getValue = getValue;
exports.parseConnectionToNormal = parseConnectionToNormal;

var React = _interopRequireWildcard(require("react"));

var _lodash = require("lodash");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// $FlowFixMe
function withContainerRouter(Com) {
  return (
    /*#__PURE__*/
    function (_React$Component) {
      _inherits(ContainerWithRouter, _React$Component);

      function ContainerWithRouter(_props) {
        var _this;

        _classCallCheck(this, ContainerWithRouter);

        _this = _possibleConstructorReturn(this, _getPrototypeOf(ContainerWithRouter).call(this, _props));

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {
          value: {},
          recordValue: {},
          originRootValue: {},
          rootValue: {},
          isFetching: false
        });

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "key", void 0);

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "subscription", void 0);

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "queryData", function (props) {
          var _ref = props || _this.props,
              refId = _ref.refId,
              fetch = _ref.fetch;

          return fetch(_this.key).then(function (data) {
            var rootValue = parseConnectionToNormal(data);

            _this.setState({
              originRootValue: data,
              rootValue: rootValue,
              recordValue: getRecordValue(rootValue, refId),
              value: getValue(data, refId.getPathArr()),
              isFetching: false
            });
          });
        });

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "subscribe", function () {
          var _this$props = _this.props,
              subscribe = _this$props.subscribe,
              refId = _this$props.refId;
          var subscription = subscribe(_this.key, function (data) {
            var rootValue = parseConnectionToNormal(data);

            _this.setState({
              originRootValue: data,
              rootValue: rootValue,
              recordValue: getRecordValue(rootValue, refId),
              value: getValue(data, refId.getPathArr()),
              isFetching: false
            });
          });
          _this.subscription = subscription;
        });

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "unsubscribe", function () {
          if (_this.subscription) {
            _this.subscription.unsubscribe();
          }
        });

        _this.key = _props.refId.getPathArr()[0];
        return _this;
      }

      _createClass(ContainerWithRouter, [{
        key: "componentDidMount",
        value: function componentDidMount() {
          if (this.key) {
            this.queryData();
            this.subscribe();
          }
        }
      }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
          this.unsubscribe();
        }
      }, {
        key: "render",
        value: function render() {
          var _this$state = this.state,
              value = _this$state.value,
              recordValue = _this$state.recordValue;
          return React.createElement(Com, _extends({}, this.props, {
            value: value,
            recordValue: recordValue
          }));
        }
      }]);

      return ContainerWithRouter;
    }(React.Component)
  );
}

function getValue(value, idPathArr) {
  return idPathArr.reduce(function (result, key) {
    if ((0, _lodash.isPlainObject)(result)) {
      if ('edges' in result && 'pageInfo' in result) {
        return (0, _lodash.get)(result, ['edges', key, 'node']);
      }

      return (0, _lodash.get)(result, key);
    } else if ((0, _lodash.isArray)(result)) {
      return (0, _lodash.get)(result, key);
    } else {
      return result;
    }
  }, value);
}

function parseConnectionToNormal(value) {
  if ((0, _lodash.isPlainObject)(value)) {
    if (value.edges && value.pageInfo) {
      return value.edges.map(function (edge) {
        return parseConnectionToNormal(edge.node);
      });
    }

    return (0, _lodash.mapValues)(value, function (item) {
      return parseConnectionToNormal(item);
    });
  } else if ((0, _lodash.isArray)(value)) {
    return value.map(function (item) {
      return parseConnectionToNormal(item);
    });
  } else {
    return value;
  }
}

function getRecordValue(rootValue, refId) {
  return (0, _lodash.get)(rootValue, refId.getPathArr(), {});
}