"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = deploy;
exports.genDeployButton = genDeployButton;
exports.genCancelButton = genCancelButton;

require("antd/lib/button/style");

var _button = _interopRequireDefault(require("antd/lib/button"));

var React = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _lodash = require("lodash");

var _cache = require("./cache");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function deploy(Com) {
  return (
    /*#__PURE__*/
    function (_React$Component) {
      _inherits(ComponentWithDeploy, _React$Component);

      function ComponentWithDeploy() {
        var _getPrototypeOf2;

        var _this;

        _classCallCheck(this, ComponentWithDeploy);

        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(ComponentWithDeploy)).call.apply(_getPrototypeOf2, [this].concat(args)));

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "deploy", function (refId, callback) {
          var deploy = _this.props.deploy;
          return deploy(refId.getPathArr()[0]).then(callback).catch(function () {});
        });

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "reset", function (refId, callback) {
          var _this$props = _this.props,
              reset = _this$props.reset,
              rootValue = _this$props.rootValue;
          var key = refId.getPathArr()[0];
          var recordId = getItemId(rootValue, refId);
          reset(key, recordId);
          callback();
        });

        return _this;
      }

      _createClass(ComponentWithDeploy, [{
        key: "render",
        value: function render() {
          var _this$props2 = this.props,
              routerParams = _this$props2.routerParams,
              routes = _this$props2.routes,
              refId = _this$props2.refId,
              path = _this$props2.path,
              pattern = _this$props2.pattern,
              controlDeployAndResetButtons = _this$props2.controlDeployAndResetButtons,
              hideButtons = _this$props2.hideButtons;
          var buttonContainer = {
            textAlign: 'right',
            marginTop: 60
          };
          var renderConfirmButton = genDeployButton(this.deploy, refId);
          var renderCancelButton = genCancelButton(this.reset, refId);
          var isCreateOp = routerParams.operator === 'create';
          var shouldRenderButtons = (routes.length === 1 || (0, _cache.isRoutesEndAtMe)({
            routes: routes,
            path: path,
            pattern: pattern
          }) && isCreateOp) && !controlDeployAndResetButtons && !hideButtons && refId.getPathArr().length <= routes.length;
          return React.createElement("div", null, React.createElement(Com, _extends({}, this.props, {
            renderConfirmButton: renderConfirmButton,
            renderCancelButton: renderCancelButton
          })), shouldRenderButtons && // $FlowFixMe
          React.createElement("div", {
            style: buttonContainer
          }, renderConfirmButton({
            callback: function callback() {// location.href = routerParams.backUrl || location.href.split('?')[0];
            },
            style: {
              marginRight: 16
            }
          }), renderCancelButton({
            hidden: isCreateOp
          })));
        }
      }]);

      return ComponentWithDeploy;
    }(React.Component)
  );
}

function genDeployButton(deploy, currentRefId) {
  return function DeployButton() {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        _ref$disabled = _ref.disabled,
        disabled = _ref$disabled === void 0 ? false : _ref$disabled,
        _ref$style = _ref.style,
        style = _ref$style === void 0 ? {
      marginRight: 16
    } : _ref$style,
        _ref$refId = _ref.refId,
        refId = _ref$refId === void 0 ? currentRefId : _ref$refId,
        _ref$onClick = _ref.onClick,
        _onClick = _ref$onClick === void 0 ? deploy : _ref$onClick,
        _ref$callback = _ref.callback,
        callback = _ref$callback === void 0 ? function () {} : _ref$callback,
        _ref$text = _ref.text,
        text = _ref$text === void 0 ? 'Confirm' : _ref$text,
        _ref$Component = _ref.Component,
        Component = _ref$Component === void 0 ? _button.default : _ref$Component;

    return React.createElement(Component, {
      disabled: disabled,
      style: style,
      type: "primary",
      onClick: function onClick() {
        return _onClick(refId, callback);
      },
      "data-testid": "confirm-button"
    }, text);
  };
}

function genCancelButton(reset, currentRefId) {
  return function CancelButton() {
    var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        _ref2$disabled = _ref2.disabled,
        disabled = _ref2$disabled === void 0 ? false : _ref2$disabled,
        _ref2$style = _ref2.style,
        style = _ref2$style === void 0 ? {} : _ref2$style,
        _ref2$refId = _ref2.refId,
        refId = _ref2$refId === void 0 ? currentRefId : _ref2$refId,
        _ref2$onClick = _ref2.onClick,
        _onClick2 = _ref2$onClick === void 0 ? reset : _ref2$onClick,
        _ref2$callback = _ref2.callback,
        callback = _ref2$callback === void 0 ? function () {} : _ref2$callback,
        _ref2$text = _ref2.text,
        text = _ref2$text === void 0 ? 'Reset' : _ref2$text,
        _ref2$Component = _ref2.Component,
        Component = _ref2$Component === void 0 ? _button.default : _ref2$Component;

    return React.createElement(Component, {
      disabled: disabled,
      style: style,
      onClick: function onClick() {
        return _onClick2(refId, callback);
      },
      "data-testid": "reset-button"
    }, text);
  };
}

function getItemId(rootValue, refId) {
  var _refId$getPathArr = refId.getPathArr(),
      _refId$getPathArr2 = _slicedToArray(_refId$getPathArr, 2),
      key = _refId$getPathArr2[0],
      index = _refId$getPathArr2[1];

  var itemId = '';
  var value = rootValue[key];

  if ((0, _lodash.isArray)(value) && index) {
    itemId = value[index].id;
  }

  return itemId;
}