"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = connectId;

var React = _interopRequireWildcard(require("react"));

var _cannerRefId = _interopRequireDefault(require("canner-ref-id"));

var _cannerHelpers = require("canner-helpers");

var _lodash = require("lodash");

var _reactContentLoader = require("react-content-loader");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function connectId(Com) {
  return (
    /*#__PURE__*/
    function (_React$Component) {
      _inherits(ComponentConnectId, _React$Component);

      function ComponentConnectId(props) {
        var _this;

        _classCallCheck(this, ComponentConnectId);

        _this = _possibleConstructorReturn(this, _getPrototypeOf(ComponentConnectId).call(this, props));

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "refId", void 0);

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "query", void 0);

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "reset", void 0);

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "args", void 0);

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "fetchById", function (id, timeIntervale) {
          var _this$props = _this.props,
              query = _this$props.query,
              keyName = _this$props.keyName,
              updateQuery = _this$props.updateQuery,
              fetch = _this$props.fetch;
          var paths = [keyName];
          var queries = query.getQueries(paths).args || {
            pagination: {
              first: 10
            }
          };
          var variables = query.getVairables(); // get current args

          _this.args = (0, _lodash.mapValues)(queries, function (v) {
            return variables[v.substr(1)];
          });

          _this.setState({
            canRender: false
          });

          updateQuery(paths, _objectSpread({}, _this.args, {
            where: {
              id: id
            }
          })).then(function () {
            return fetch(keyName);
          }).then(function (result) {
            var index = 0;

            if (result[keyName].edges) {
              index = result[keyName].edges.findIndex(function (edge) {
                return edge.cursor === id;
              });
            } else {
              index = result[keyName].findIndex(function (item) {
                return item.id === id;
              });
            }

            setTimeout(function () {
              _this.setState({
                canRender: true,
                refId: new _cannerRefId.default("".concat(keyName, "/").concat(index))
              });
            }, timeIntervale || 0);
          });
        });

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "createArray",
        /*#__PURE__*/
        function () {
          var _ref = _asyncToGenerator(
          /*#__PURE__*/
          regeneratorRuntime.mark(function _callee(keyName, value) {
            var _this$props2, fetch, request, updateQuery;

            return regeneratorRuntime.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    _this$props2 = _this.props, fetch = _this$props2.fetch, request = _this$props2.request, updateQuery = _this$props2.updateQuery;
                    _context.next = 3;
                    return updateQuery([keyName], {
                      first: 0
                    });

                  case 3:
                    _context.next = 5;
                    return fetch(keyName).then(function (result) {
                      var size = (0, _lodash.get)(result, [keyName, 'edges']).length; // $FlowFixMe

                      return request({
                        type: 'CREATE_ARRAY',
                        payload: {
                          id: value.id,
                          value: value,
                          key: keyName
                        }
                      }).then(function () {
                        return size;
                      });
                    }).then(function (size) {
                      _this.setState({
                        canRender: true,
                        refId: new _cannerRefId.default("".concat(keyName, "/").concat(size))
                      });
                    });

                  case 5:
                  case "end":
                    return _context.stop();
                }
              }
            }, _callee, this);
          }));

          return function (_x, _x2) {
            return _ref.apply(this, arguments);
          };
        }());

        var routerParams = props.routerParams,
            pattern = props.pattern,
            refId = props.refId,
            _keyName = props.keyName,
            routes = props.routes;
        var myRefId = refId; // route to children

        if (routerParams.operator === 'create' && pattern === 'array') {
          _this.state = {
            canRender: false,
            refId: refId
          };
        } else if (pattern === 'array' && routes.length > 1) {
          // in this case,
          // this hoc will fetch data with query {where: {id: id}} in componentDidMount
          _this.state = {
            canRender: false,
            refId: null
          };
        } else {
          myRefId = myRefId ? myRefId.child(_keyName) : new _cannerRefId.default(_keyName);
          _this.state = {
            canRender: true,
            refId: myRefId
          };
        }

        return _this;
      }

      _createClass(ComponentConnectId, [{
        key: "UNSAFE_componentWillReceiveProps",
        value: function UNSAFE_componentWillReceiveProps(props) {
          var _this2 = this;

          var _props$routerParams = props.routerParams,
              operator = _props$routerParams.operator,
              payload = _props$routerParams.payload,
              pattern = props.pattern,
              items = props.items,
              keyName = props.keyName,
              routes = props.routes,
              updateQuery = props.updateQuery;

          if (operator === 'create' && this.props.routerParams.operator === 'update' && pattern === 'array') {
            // posts => posts?op=create
            var value = (0, _cannerHelpers.createEmptyData)(items);
            (0, _lodash.update)(value, 'id', function (id) {
              return id || randomId();
            });
            (0, _lodash.update)(value, '__typename', function (typename) {
              return typename || null;
            });
            this.setState({
              canRender: false
            });

            if (payload) {
              value = (0, _lodash.merge)(value, payload);
            }

            this.createArray(keyName, value);
          }

          if (operator === 'update' && this.props.routerParams.operator === 'create' && pattern === 'array') {
            // posts?op=create => posts
            updateQuery([keyName], {
              first: 10,
              where: {}
            }).then(function () {
              _this2.setState({
                refId: new _cannerRefId.default(keyName)
              });
            });
          }

          if (pattern === 'array' && routes.length > 1 && this.props.routes.length === 1) {
            // posts => posts/<postId>
            this.setState({
              canRender: false
            });
            this.fetchById(routes[1], 400);
          }

          if (pattern === 'array' && routes.length === 1 && this.args && this.props.routes.length > 1) {
            // posts/<postId> => posts
            this.setState({
              refId: new _cannerRefId.default("".concat(keyName))
            });
            updateQuery([keyName], this.args).then(function () {
              delete _this2.args;
            });
          }
        }
      }, {
        key: "componentDidMount",
        value: function componentDidMount() {
          var _this$props3 = this.props,
              routerParams = _this$props3.routerParams,
              pattern = _this$props3.pattern,
              keyName = _this$props3.keyName,
              items = _this$props3.items,
              routes = _this$props3.routes;

          if (routerParams.operator === 'create' && pattern === 'array') {
            // posts?op=create
            var value = (0, _cannerHelpers.createEmptyData)(items);
            (0, _lodash.update)(value, 'id', function (id) {
              return id || randomId();
            });
            (0, _lodash.update)(value, '__typename', function (typename) {
              return typename || null;
            });

            if (routerParams.payload) {
              value = (0, _lodash.merge)(value, routerParams.payload);
            }

            this.createArray(keyName, value);
          } else if (pattern === 'array' && routes.length > 1) {
            // posts/<postId>/title
            this.fetchById(routes[1]);
          } else {
            this.setState({
              canRender: true
            });
          }
        }
      }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
          var _this$props4 = this.props,
              updateQuery = _this$props4.updateQuery,
              keyName = _this$props4.keyName,
              pattern = _this$props4.pattern;

          if (pattern === 'array' && this.args) {
            updateQuery([keyName], this.args);
          }
        }
      }, {
        key: "render",
        value: function render() {
          var _this$state = this.state,
              canRender = _this$state.canRender,
              refId = _this$state.refId;
          if (!canRender) return React.createElement(_reactContentLoader.List, {
            style: {
              maxWidth: 600
            }
          });
          return React.createElement(Com, _extends({}, this.props, {
            refId: refId
          }));
        }
      }]);

      return ComponentConnectId;
    }(React.Component)
  );
}

function randomId() {
  return Math.random().toString(36).substr(2, 12);
}