"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = withQuery;
exports.shouldUpdate = shouldUpdate;

require("antd/lib/spin/style");

var _spin = _interopRequireDefault(require("antd/lib/spin"));

require("antd/lib/icon/style");

var _icon = _interopRequireDefault(require("antd/lib/icon"));

var React = _interopRequireWildcard(require("react"));

var _reactContentLoader = require("react-content-loader");

var _index = _interopRequireDefault(require("../components/toolbar/index"));

var _antd = require("antd");

var _lodash = require("lodash");

var _utils = require("./utils");

var _reactApollo = require("react-apollo");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function withQuery(Com) {
  var _class;

  return (0, _reactApollo.withApollo)(_class =
  /*#__PURE__*/
  function (_React$PureComponent) {
    _inherits(ComponentWithQuery, _React$PureComponent);

    function ComponentWithQuery(_props) {
      var _this;

      _classCallCheck(this, ComponentWithQuery);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(ComponentWithQuery).call(this, _props));

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "key", void 0);

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "subscription", void 0);

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "unsubscribe", function () {
        if (_this.subscription) {
          _this.subscription.unsubscribe();
        }
      });

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "subscribe", function () {
        var subscribe = _this.props.subscribe;
        var subscription = subscribe(_this.key, function (data) {
          _this.updateData(data);
        });
        _this.subscription = subscription;
      });

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "queryData", function (props) {
        var _ref = props || _this.props,
            fetch = _ref.fetch;

        _this.setState({
          isFetching: true
        });

        return fetch(_this.key).then(_this.updateData);
      });

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "updateData", function (data) {
        var refId = _this.props.refId;

        _this.setState({
          originRootValue: data,
          rootValue: (0, _utils.parseConnectionToNormal)(data),
          value: (0, _utils.getValue)(data, refId.getPathArr()),
          isFetching: false
        });
      });

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "updateQuery", function (paths, args) {
        var updateQuery = _this.props.updateQuery;
        updateQuery(paths, args).then(function (rewatch) {
          if (rewatch) {
            _this.unsubscribe();

            _this.queryData();

            _this.subscribe();
          } else {
            _this.queryData();
          }
        });
      });

      _this.state = {
        value: null,
        rootValue: null,
        originRootValue: null,
        isFetching: true
      };
      _this.key = _props.refId.getPathArr()[0];
      return _this;
    }

    _createClass(ComponentWithQuery, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        var _this2 = this;

        this.queryData().then(function () {
          _this2.subscribe();
        });
      }
    }, {
      key: "componentWillUnmount",
      value: function componentWillUnmount() {
        this.unsubscribe();
      }
    }, {
      key: "componentDidUpdate",
      value: function componentDidUpdate(prevProps) {
        var _this3 = this;

        var refId = prevProps.refId;

        if (refId.toString() !== this.props.refId.toString()) {
          // refetch when route change
          this.unsubscribe();
          this.queryData(this.props).then(function () {
            _this3.subscribe();
          });
        }
      }
    }, {
      key: "render",
      value: function render() {
        var _this$state = this.state,
            value = _this$state.value,
            isFetching = _this$state.isFetching,
            rootValue = _this$state.rootValue,
            originRootValue = _this$state.originRootValue;
        var _this$props = this.props,
            toolbar = _this$props.toolbar,
            query = _this$props.query,
            refId = _this$props.refId,
            items = _this$props.items,
            type = _this$props.type,
            path = _this$props.path,
            relation = _this$props.relation,
            pattern = _this$props.pattern,
            keyName = _this$props.keyName,
            request = _this$props.request,
            deploy = _this$props.deploy,
            nullable = _this$props.nullable;

        if (!originRootValue) {
          return React.createElement(_reactContentLoader.List, {
            style: {
              maxWidth: '600px'
            }
          });
        }

        if (pattern === 'array') {
          var queries = query.getQueries(path.split('/')).args || {
            pagination: {
              first: 10
            }
          };
          var variables = query.getVairables();
          var args = (0, _lodash.mapValues)(queries, function (v) {
            return variables[v.substr(1)];
          });
          return React.createElement(_index.default, {
            items: items,
            toolbar: toolbar,
            args: args,
            query: query,
            refId: refId,
            keyName: keyName,
            originRootValue: originRootValue,
            parseConnectionToNormal: _utils.parseConnectionToNormal,
            getValue: _utils.getValue,
            defaultValue: _utils.defaultValue,
            updateQuery: this.updateQuery,
            request: request,
            deploy: deploy
          }, React.createElement(SpinWrapper, {
            isFetching: isFetching
          }, React.createElement(Com, this.props)));
        } else if (type === 'relation' && relation.type === 'toOne') {
          return React.createElement(Com, _extends({}, this.props, {
            showPagination: true,
            rootValue: rootValue,
            value: value && value.id ? value : (0, _utils.defaultValue)(type, relation)
          }));
        } else if (type === 'relation' && relation.type === 'toMany') {
          return React.createElement(Com, _extends({}, this.props, {
            showPagination: true,
            rootValue: rootValue,
            value: (0, _lodash.isNil)(value) ? (0, _utils.defaultValue)('array', undefined, nullable) : value
          }));
        }

        return React.createElement(Com, _extends({}, this.props, {
          showPagination: true,
          rootValue: rootValue,
          value: (0, _lodash.isNil)(value) ? (0, _utils.defaultValue)(type, relation, nullable) : value
        }));
      }
    }]);

    return ComponentWithQuery;
  }(React.PureComponent)) || _class;
}

var antIcon = React.createElement(_icon.default, {
  type: "loading",
  style: {
    fontSize: 24
  },
  spin: true
});

function SpinWrapper(_ref2) {
  var isFetching = _ref2.isFetching,
      children = _ref2.children,
      props = _objectWithoutProperties(_ref2, ["isFetching", "children"]);

  return React.createElement(_spin.default, {
    indicator: antIcon,
    spinning: isFetching
  }, React.cloneElement(children, props));
}

function shouldUpdate(value, newValue) {
  return value != newValue;
}