"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = withRoute;
exports.getRenderType = getRenderType;
exports.isCompleteContain = isCompleteContain;
exports.genPaths = genPaths;
exports.RENDER_NULL = exports.RENDER_COMPONENT = exports.RENDER_CHILDREN = void 0;

require("antd/lib/spin/style");

var _spin = _interopRequireDefault(require("antd/lib/spin"));

require("antd/lib/button/style");

var _button = _interopRequireDefault(require("antd/lib/button"));

require("antd/lib/icon/style");

var _icon = _interopRequireDefault(require("antd/lib/icon"));

require("antd/lib/modal/style");

var _modal = _interopRequireDefault(require("antd/lib/modal"));

var React = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _reactIntl = require("react-intl");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  text-align: right;\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var confirm = _modal.default.confirm;
var RENDER_CHILDREN = 0;
exports.RENDER_CHILDREN = RENDER_CHILDREN;
var RENDER_COMPONENT = 1;
exports.RENDER_COMPONENT = RENDER_COMPONENT;
var RENDER_NULL = 2;
exports.RENDER_NULL = RENDER_NULL;

var ButtonWrapper = _styledComponents.default.div(_templateObject());

function withRoute(Com) {
  var _class;

  return (0, _reactIntl.injectIntl)(_class =
  /*#__PURE__*/
  function (_React$Component) {
    _inherits(ComWithRoute, _React$Component);

    function ComWithRoute(props) {
      var _this;

      _classCallCheck(this, ComWithRoute);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(ComWithRoute).call(this, props));

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "deploy", function () {
        var _this$props = _this.props,
            refId = _this$props.refId,
            deploy = _this$props.deploy,
            intl = _this$props.intl;

        _this.setState({
          loading: true,
          loadingTip: intl.formatMessage({
            id: 'hocs.route.deployingTip'
          })
        });

        deploy(refId.getPathArr()[0]).then(_this.success).catch(_this.fail);
      });

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "reset", function () {
        var _this$props2 = _this.props,
            refId = _this$props2.refId,
            reset = _this$props2.reset,
            intl = _this$props2.intl;

        _this.setState({
          loading: true,
          loadingTip: intl.formatMessage({
            id: 'hocs.route.resetingTip'
          })
        });

        reset(refId.getPathArr()[0]).then(_this.success).catch(_this.fail);
      });

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "success", function () {
        var _this$props3 = _this.props,
            goTo = _this$props3.goTo,
            routes = _this$props3.routes,
            hideBackButton = _this$props3.hideBackButton;
        setTimeout(function () {
          _this.setState({
            loading: false
          }, function () {
            !hideBackButton && goTo({
              pathname: routes[0]
            });
          });
        }, 400);
      });

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "fail", function () {
        _this.setState({
          loading: false
        });
      });

      _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "discard", function () {
        var _this$props4 = _this.props,
            goTo = _this$props4.goTo,
            routes = _this$props4.routes,
            routerParams = _this$props4.routerParams,
            reset = _this$props4.reset,
            refId = _this$props4.refId,
            dataChanged = _this$props4.dataChanged,
            intl = _this$props4.intl,
            hideBackButton = _this$props4.hideBackButton;

        var resetCondFn = function resetCondFn() {
          if (routerParams.operator === 'create') {
            reset(refId.getPathArr()[0]).then(function () {
              return !hideBackButton && goTo({
                pathname: routes.join('/')
              });
            });
          } else {
            reset(refId.getPathArr()[0]).then(function () {
              return !hideBackButton && goTo({
                pathname: routes.slice(0, -1).join('/')
              });
            });
          }
        };

        if (dataChanged && Object.keys(dataChanged).length > 0) {
          confirm({
            title: intl.formatMessage({
              id: 'hocs.route.confirm.title'
            }),
            content: intl.formatMessage({
              id: 'hocs.route.confirm.content'
            }),
            okText: intl.formatMessage({
              id: 'hocs.route.confirm.okText'
            }),
            cancelText: intl.formatMessage({
              id: 'hocs.route.confirm.cancelText'
            }),
            onOk: function onOk() {
              return new Promise(function (resolve) {
                setTimeout(resolve, 200);
              }).then().then(function () {
                resetCondFn();
              });
            },
            onCancel: function onCancel() {}
          });
        } else {
          resetCondFn();
        }
      });

      var _intl = props.intl;
      _this.state = {
        loading: false,
        loadingTip: _intl.formatMessage({
          id: 'hocs.route.loadingTip'
        })
      };
      return _this;
    }

    _createClass(ComWithRoute, [{
      key: "render",
      value: function render() {
        var _this$state = this.state,
            loading = _this$state.loading,
            loadingTip = _this$state.loadingTip;
        var _this$props5 = this.props,
            routes = _this$props5.routes,
            pattern = _this$props5.pattern,
            path = _this$props5.path,
            intl = _this$props5.intl,
            routerParams = _this$props5.routerParams,
            refId = _this$props5.refId,
            renderChildren = _this$props5.renderChildren,
            hideButtons = _this$props5.hideButtons,
            hideBackButton = _this$props5.hideBackButton,
            uiParams = _this$props5.uiParams;
        var renderType = getRenderType({
          pattern: pattern,
          routes: routes,
          path: path,
          routerParams: routerParams
        });
        var pathArrLength = refId.getPathArr().length;
        var routesLength = routes.length;
        var operator = routerParams.operator;
        var renderKeys = uiParams && uiParams.updateKeys; // render all

        if (operator === 'create') {
          renderKeys = uiParams && uiParams.createKeys;
        }

        return React.createElement(_spin.default, {
          tip: loadingTip,
          spinning: loading
        }, // quick fix for route array's children
        // need to find a stable way to control route
        renderType === RENDER_CHILDREN && !hideBackButton && pattern === 'array' && (routesLength === pathArrLength || routesLength + 1 === pathArrLength && operator === 'create') && React.createElement(_button.default, {
          onClick: this.discard,
          style: {
            marginBottom: 16
          },
          "data-testid": "back-button"
        }, React.createElement(_icon.default, {
          type: "arrow-left"
        }), " ", intl.formatMessage({
          id: 'hocs.route.backText'
        })), renderType === RENDER_CHILDREN && renderChildren(function (node) {
          return {
            hidden: renderKeys && renderKeys.indexOf(node.keyName) === -1,
            refId: refId
          };
        }), // quick fix for route array's children
        // need to find a stable way to control route
        renderType === RENDER_CHILDREN && pattern === 'array' && !hideButtons && (routesLength === pathArrLength || routesLength + 1 === pathArrLength && operator === 'create') && React.createElement(ButtonWrapper, null, React.createElement(_button.default, {
          style: {
            marginRight: 16
          },
          type: "primary",
          onClick: this.deploy,
          "data-testid": "confirm-button"
        }, intl.formatMessage({
          id: 'hocs.route.confirmText'
        })), React.createElement(_button.default, {
          onClick: this.reset,
          "data-testid": "reset-button"
        }, intl.formatMessage({
          id: 'hocs.route.resetText'
        }))), renderType === RENDER_COMPONENT && React.createElement(Com, this.props));
      }
    }]);

    return ComWithRoute;
  }(React.Component)) || _class;
}

function getRenderType(_ref) {
  var routes = _ref.routes,
      path = _ref.path,
      pattern = _ref.pattern,
      routerParams = _ref.routerParams;
  var paths = genPaths(path, pattern);
  var pathsLength = paths.length;
  var routesLength = routes.length;

  if (routes[0] !== paths[0]) {
    return RENDER_NULL;
  }

  var type = pattern.split('.').slice(-1)[0];
  var operator = routerParams.operator;

  if (type === 'object') {
    if (routesLength === pathsLength && isCompleteContain(paths, routes)) {
      return RENDER_COMPONENT;
    }

    if (routesLength < pathsLength) {
      return RENDER_COMPONENT;
    }

    if (routesLength > pathsLength) {
      return RENDER_CHILDREN;
    }

    return RENDER_NULL;
  } else if (type === 'array') {
    if (routesLength === pathsLength && isCompleteContain(paths, routes)) {
      return RENDER_CHILDREN;
    }

    if (routesLength < pathsLength) {
      if (routesLength === pathsLength - 1 && operator === 'create') {
        return RENDER_CHILDREN;
      }

      return RENDER_COMPONENT;
    }

    if (routesLength > pathsLength) {
      return RENDER_COMPONENT;
    }

    return RENDER_NULL;
  } else {
    if (routesLength === pathsLength && isCompleteContain(paths, routes)) {
      return RENDER_NULL;
    }

    if (routesLength < pathsLength) {
      return RENDER_COMPONENT;
    }

    if (routesLength > pathsLength) {
      return RENDER_COMPONENT;
    }

    return RENDER_NULL;
  }
}

function isCompleteContain(paths, routes) {
  return paths.map(function (key, i) {
    return routes[i] === key || key === '__ARRAY_INDEX__';
  }).reduce(function (result, curr) {
    return result && curr;
  });
}

function genPaths(path, pattern) {
  var patterns = pattern.split('.');
  var indexs = patterns.map(function (type, i) {
    return type === 'array' ? i : -1;
  }).filter(function (index) {
    return index !== -1;
  });
  var paths = path.split('/').map(function (route, i) {
    return indexs.indexOf(i) === -1 ? route : [].concat(route, '__ARRAY_INDEX__');
  }).reduce(function (result, curr) {
    return result.concat(curr);
  }, []);
  return paths;
}