"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Label = Label;
exports.default = withTitleAndDescription;

require("antd/lib/row/style");

var _row = _interopRequireDefault(require("antd/lib/row"));

require("antd/lib/alert/style");

var _alert = _interopRequireDefault(require("antd/lib/alert"));

require("antd/lib/col/style");

var _col = _interopRequireDefault(require("antd/lib/col"));

require("antd/lib/tooltip/style");

var _tooltip = _interopRequireDefault(require("antd/lib/tooltip"));

require("antd/lib/icon/style");

var _icon = _interopRequireDefault(require("antd/lib/icon"));

var React = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _context = require("./context");

var _cannerHelpers = require("canner-helpers");

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _lodash = require("lodash");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _templateObject2() {
  var data = _taggedTemplateLiteral(["\n  color: red;\n  font-size: 14px;\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  color: rgba(0, 0, 0, 0.85);\n  padding: ", "\n\n  & > span:before {\n    content: ", ";\n    color: red;\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var Title = _styledComponents.default.div(_templateObject(), function (props) {
  return props.layout === 'horizontal' ? 0 : '0 0 8px';
}, function (props) {
  return props.required && props.title ? '"* "' : '""';
});

var ErrorMessage = _styledComponents.default.div(_templateObject2());

function Label(_ref) {
  var required = _ref.required,
      description = _ref.description,
      title = _ref.title,
      layout = _ref.layout;
  return React.createElement(Title, {
    required: required,
    title: title,
    layout: layout
  }, React.createElement("span", null, title), title && description && React.createElement(_tooltip.default, {
    placement: "top",
    title: description
  }, React.createElement(_icon.default, {
    type: "info-circle-o",
    style: {
      marginLeft: 12,
      color: '#aaa'
    }
  })));
} // $FlowFixMe


function withTitleAndDescription(Com) {
  return (
    /*#__PURE__*/
    function (_React$Component) {
      _inherits(ComponentWithTitleAndDescription, _React$Component);

      function ComponentWithTitleAndDescription() {
        _classCallCheck(this, ComponentWithTitleAndDescription);

        return _possibleConstructorReturn(this, _getPrototypeOf(ComponentWithTitleAndDescription).apply(this, arguments));
      }

      _createClass(ComponentWithTitleAndDescription, [{
        key: "render",
        value: function render() {
          var _this$props = this.props,
              title = _this$props.title,
              layout = _this$props.layout,
              description = _this$props.description,
              hideTitle = _this$props.hideTitle,
              fetch = _this$props.fetch,
              subscribe = _this$props.subscribe,
              request = _this$props.request,
              deploy = _this$props.deploy,
              reset = _this$props.reset,
              query = _this$props.query,
              renderChildren = _this$props.renderChildren,
              renderComponent = _this$props.renderComponent,
              renderConfirmButton = _this$props.renderConfirmButton,
              renderCancelButton = _this$props.renderCancelButton,
              refId = _this$props.refId,
              routes = _this$props.routes,
              updateQuery = _this$props.updateQuery,
              type = _this$props.type,
              imageStorage = _this$props.imageStorage,
              onDeploy = _this$props.onDeploy,
              removeOnDeploy = _this$props.removeOnDeploy,
              required = _this$props.required,
              dataChanged = _this$props.dataChanged,
              error = _this$props.error,
              errorInfo = _this$props.errorInfo;
          var labelCol = layout === 'horizontal' ? this.props.labelCol || {
            span: 6
          } : null;
          var itemCol = layout === 'horizontal' ? this.props.itemCol || {
            span: 14
          } : null; // $FlowFixMe: default funcitons in HOCContext only throw error, so they don't have any arguments

          return React.createElement(_context.HOCContext.Provider, {
            value: {
              fetch: fetch,
              subscribe: subscribe,
              request: request,
              deploy: deploy,
              reset: reset,
              query: query,
              updateQuery: updateQuery,
              onDeploy: onDeploy,
              removeOnDeploy: removeOnDeploy,
              dataChanged: dataChanged
            }
          }, React.createElement(_cannerHelpers.Context.Provider, {
            value: {
              renderChildren: renderChildren,
              renderComponent: renderComponent,
              renderConfirmButton: renderConfirmButton,
              renderCancelButton: renderCancelButton,
              refId: refId,
              routes: routes
            }
          }, React.createElement(_row.default, {
            type: layout === 'horizontal' ? 'flex' : '',
            style: {
              marginBottom: 24
            }
          }, React.createElement(_col.default, labelCol, React.createElement(Label, {
            required: required,
            type: type,
            layout: layout,
            description: description,
            title: hideTitle ? '' : title
          })), React.createElement(_col.default, itemCol, type === 'image' && (0, _lodash.isEmpty)(imageStorage) && React.createElement(_alert.default, {
            style: {
              margin: '16px 0'
            },
            message: "There is no storage config so you can't upload image. Checkout the storage section to know more",
            type: "warning"
          }), React.createElement(Com, this.props), error && React.createElement(ErrorMessage, null, errorInfo[0].message)))));
        }
      }]);

      return ComponentWithTitleAndDescription;
    }(React.Component)
  );
}