"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = withValidation;
exports.splitRefId = splitRefId;
exports.getValueAndPaths = getValueAndPaths;

var React = _interopRequireWildcard(require("react"));

var _cannerRefId = _interopRequireDefault(require("canner-ref-id"));

var _ajv = _interopRequireDefault(require("ajv"));

var _lodash = require("lodash");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function withValidation(Com) {
  return (
    /*#__PURE__*/
    function (_React$Component) {
      _inherits(ComponentWithValition, _React$Component);

      function ComponentWithValition() {
        var _getPrototypeOf2;

        var _this;

        _classCallCheck(this, ComponentWithValition);

        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(ComponentWithValition)).call.apply(_getPrototypeOf2, [this].concat(args)));

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "key", void 0);

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "id", void 0);

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "callbackId", void 0);

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {
          error: false,
          errorInfo: []
        });

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "validate", function (result) {
          var _this$props = _this.props,
              refId = _this$props.refId,
              _this$props$validatio = _this$props.validation,
              validation = _this$props$validatio === void 0 ? {} : _this$props$validatio,
              _this$props$required = _this$props.required,
              required = _this$props$required === void 0 ? false : _this$props$required; // required

          var paths = refId.getPathArr().slice(1);

          var _getValueAndPaths = getValueAndPaths(result.data, paths),
              value = _getValueAndPaths.value;

          var isRequiredValid = required ? Boolean(value) : true; // Ajv validation

          var ajv = new _ajv.default();
          var validate = ajv.compile(validation); // custom validator

          var validator = validation.validator,
              errorMessage = validation.errorMessage;

          var reject = function reject(message) {
            return {
              error: true,
              message: message
            };
          };

          var validatorResult = validator && validator(value, reject);
          var customValid = !(validatorResult && validatorResult.error); // if value is empty, should not validate with ajv

          if (customValid && isRequiredValid && (!value || validate(value))) {
            _this.setState({
              error: false,
              errorInfo: []
            });

            return result;
          }

          var errorInfo = [].concat(isRequiredValid ? [] : {
            message: 'should be required'
          }).concat(validate.errors ? errorMessage ? {
            message: errorMessage
          } : validate.errors : []).concat(customValid ? [] : validatorResult);

          _this.setState({
            error: true,
            errorInfo: errorInfo
          });

          return _objectSpread({}, result, {
            error: true,
            errorInfo: errorInfo
          });
        });

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "removeOnDeploy", function () {
          var _this$props2 = _this.props,
              refId = _this$props2.refId,
              removeOnDeploy = _this$props2.removeOnDeploy;

          if (_this.callbackId) {
            removeOnDeploy(refId.getPathArr()[0], _this.callbackId || '');
          }
        });

        return _this;
      }

      _createClass(ComponentWithValition, [{
        key: "componentDidMount",
        value: function componentDidMount() {
          var _this$props3 = this.props,
              refId = _this$props3.refId,
              _this$props3$validati = _this$props3.validation,
              validation = _this$props3$validati === void 0 ? {} : _this$props3$validati,
              onDeploy = _this$props3.onDeploy,
              _this$props3$required = _this$props3.required,
              required = _this$props3$required === void 0 ? false : _this$props3$required;

          if ((0, _lodash.isEmpty)(validation) && !required) {
            // no validation
            return;
          }

          var key = refId.getPathArr()[0];
          this.callbackId = onDeploy(key, this.validate);
        }
      }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
          this.removeOnDeploy();
        }
      }, {
        key: "render",
        value: function render() {
          var _this$state = this.state,
              error = _this$state.error,
              errorInfo = _this$state.errorInfo;
          return React.createElement(React.Fragment, null, React.createElement(Com, _extends({}, this.props, {
            error: error,
            errorInfo: errorInfo || []
          })));
        }
      }]);

      return ComponentWithValition;
    }(React.Component)
  );
}

function splitRefId(_ref) {
  var refId = _ref.refId,
      rootValue = _ref.rootValue,
      pattern = _ref.pattern;

  var _refId$getPathArr = refId.getPathArr(),
      _refId$getPathArr2 = _slicedToArray(_refId$getPathArr, 2),
      key = _refId$getPathArr2[0],
      index = _refId$getPathArr2[1];

  var id;

  if (pattern.startsWith('array')) {
    id = (0, _lodash.get)(rootValue, [key, index, 'id']);
  }

  return {
    key: key,
    id: id
  };
}

function getValueAndPaths(value, idPathArr) {
  return idPathArr.reduce(function (result, key) {
    var v = result.value;
    var paths = result.paths;

    if ((0, _lodash.isPlainObject)(v)) {
      if ('edges' in v && 'pageInfo' in v) {
        v = (0, _lodash.get)(v, ['edges', key, 'node']);
        paths = paths.concat(['edges', key, 'node']);
      } else {
        v = v[key];
        paths = paths.concat(key);
      }
    } else if ((0, _lodash.isArray)(v)) {
      v = v[key];
      paths = paths.concat(key);
    }

    return {
      value: v,
      paths: paths
    };
  }, {
    value: value,
    paths: []
  });
}