"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Query = void 0;

var _utils = require("./utils");

var _lodash = require("lodash");

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Query = function Query(_ref) {
  var _this = this;

  var schema = _ref.schema;

  _classCallCheck(this, Query);

  _defineProperty(this, "schema", void 0);

  _defineProperty(this, "queries", void 0);

  _defineProperty(this, "variables", void 0);

  _defineProperty(this, "updateQueries", function (pathArr, field, value) {
    var path = "".concat(pathArr.join('.fields.'), ".").concat(field);

    if (field === 'args') {
      var args = (0, _lodash.get)(_this.queries, path);
      _this.variables = _objectSpread({}, _this.variables, Object.keys(args).reduce(function (result, key) {
        result[args[key]] = value[key];
        return result;
      }, {}));
    } else {
      (0, _lodash.set)(_this.queries, path, value);
    }
  });

  _defineProperty(this, "getQueries", function (pathArr) {
    if (!pathArr || pathArr.length === 0) {
      return _this.queries;
    }

    var path = pathArr.join('.fields.');
    return (0, _lodash.get)(_this.queries, path);
  });

  _defineProperty(this, "toGQL", function (key) {
    var variables = _this.getVairables();

    if (key) {
      var obj = _this.getQueries([key]);

      return (0, _utils.objectToQueries)(_defineProperty({}, key, obj), !obj.declareArgs, variables);
    } else {
      return (0, _utils.objectToQueries)(_this.queries, false, variables);
    }
  });

  _defineProperty(this, "getVairables", function () {
    return (0, _lodash.mapKeys)(_this.variables, function (value, key) {
      return key.substr(1);
    });
  });

  this.schema = schema;

  var _schemaToQueriesObjec = (0, _utils.schemaToQueriesObject)(schema),
      queriesObj = _schemaToQueriesObjec.queriesObj,
      _variables = _schemaToQueriesObjec.variables;

  this.variables = _variables;
  this.queries = queriesObj;
};

exports.Query = Query;