"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _forEach2 = _interopRequireDefault(require("lodash/forEach"));

var _utils = require("./utils");

var _types = require("./types");

var _nullField = _interopRequireDefault(require("./nullField"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ArrayField =
/*#__PURE__*/
function () {
  function ArrayField(_ref) {
    var rootSchema = _ref.rootSchema,
        schema = _ref.schema,
        key = _ref.key,
        isEntity = _ref.isEntity;

    _classCallCheck(this, ArrayField);

    _defineProperty(this, "schema", void 0);

    _defineProperty(this, "rootSchema", void 0);

    _defineProperty(this, "key", void 0);

    _defineProperty(this, "isEntity", void 0);

    this.key = key;
    this.rootSchema = rootSchema;
    this.schema = schema;
    this.isEntity = isEntity || false;
  }

  _createClass(ArrayField, [{
    key: "getAttr",
    value: function getAttr(name) {
      return this.schema[name];
    }
  }, {
    key: "getKey",
    value: function getKey() {
      return this.key;
    }
  }, {
    key: "getType",
    value: function getType() {
      return _types.types.ARRAY;
    }
  }, {
    key: "exists",
    value: function exists() {
      return true;
    }
  }, {
    key: "getChild",
    value: function getChild(fieldName) {
      if ((0, _utils.isCompositeType)(this.schema.items.type)) {
        var child = (0, _utils.createField)(fieldName, this.rootSchema, this.schema.items);
        var childField = child.getChild(fieldName);
        return childField;
      }

      if (!this.schema.items || !this.schema.items.items || !this.schema.items.items[fieldName]) {
        return new _nullField.default({
          key: fieldName
        });
      } // array of object


      var field = (0, _utils.createField)(fieldName, this.rootSchema, this.schema.items.items[fieldName]);
      return field;
    }
  }, {
    key: "forEach",
    value: function forEach(visitor) {
      var _this = this;

      if ((0, _utils.isCompositeType)(this.schema.items.type)) {
        var child = (0, _utils.createField)('', this.rootSchema, this.schema.items);
        child.forEach(visitor);
        return;
      }

      (0, _forEach2.default)(this.schema.items.items, function (item, key) {
        var field = (0, _utils.createField)(key, _this.rootSchema, _this.schema.items.items[key]);
        visitor(field);
      });
    }
  }]);

  return ArrayField;
}();

exports.default = ArrayField;