"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _forEach2 = _interopRequireDefault(require("lodash/forEach"));

var _utils = require("./utils");

var _nullField = _interopRequireDefault(require("./nullField"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var CompositeField =
/*#__PURE__*/
function () {
  function CompositeField(_ref) {
    var type = _ref.type,
        rootSchema = _ref.rootSchema,
        childFields = _ref.childFields,
        key = _ref.key;

    _classCallCheck(this, CompositeField);

    _defineProperty(this, "rootSchema", void 0);

    _defineProperty(this, "childFields", void 0);

    _defineProperty(this, "key", void 0);

    _defineProperty(this, "type", void 0);

    this.key = key;
    this.type = type;
    this.rootSchema = rootSchema;
    this.childFields = childFields;
  }

  _createClass(CompositeField, [{
    key: "getKey",
    value: function getKey() {
      return this.key;
    }
  }, {
    key: "exists",
    value: function exists() {
      return true;
    }
  }, {
    key: "getType",
    value: function getType() {
      return this.type;
    }
  }, {
    key: "getChild",
    value: function getChild(fieldName) {
      if (!this.childFields || !this.childFields[fieldName]) {
        return new _nullField.default({
          key: fieldName
        });
      }

      var field = (0, _utils.createField)(fieldName, this.rootSchema, this.childFields[fieldName]);
      return field;
    }
  }, {
    key: "forEach",
    value: function forEach(visitor) {
      var _this = this;

      if (!this.childFields) {
        return;
      }

      (0, _forEach2.default)(this.childFields, function (item, key) {
        var field = (0, _utils.createField)(key, _this.rootSchema, _this.childFields[key]);
        visitor(field);
      });
    }
  }]);

  return CompositeField;
}();

exports.default = CompositeField;