"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _forEach2 = _interopRequireDefault(require("lodash/forEach"));

var _types = require("./types");

var _utils = require("./utils");

var _nullField = _interopRequireDefault(require("./nullField"));

var pluralize = _interopRequireWildcard(require("pluralize"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var RelationField =
/*#__PURE__*/
function () {
  function RelationField(_ref) {
    var rootSchema = _ref.rootSchema,
        schema = _ref.schema,
        key = _ref.key;

    _classCallCheck(this, RelationField);

    _defineProperty(this, "schema", void 0);

    _defineProperty(this, "key", void 0);

    _defineProperty(this, "relationSchema", void 0);

    _defineProperty(this, "rootSchema", void 0);

    this.key = key;
    this.schema = schema;
    this.rootSchema = rootSchema;
    this.relationSchema = rootSchema[this.schema.relation.to];
  }

  _createClass(RelationField, [{
    key: "exists",
    value: function exists() {
      return true;
    }
  }, {
    key: "getKey",
    value: function getKey() {
      return this.key;
    }
  }, {
    key: "getType",
    value: function getType() {
      return _types.types.RELATION;
    }
  }, {
    key: "isToOne",
    value: function isToOne() {
      return this.schema.relation && this.schema.relation.type === 'toOne';
    }
  }, {
    key: "isToMany",
    value: function isToMany() {
      return this.schema.relation && this.schema.relation.type === 'toMany';
    }
  }, {
    key: "relationTo",
    value: function relationTo() {
      return this.schema.relation.to;
    }
  }, {
    key: "getRelationFields",
    value: function getRelationFields() {
      return this.schema.relation.fields || [];
    }
  }, {
    key: "getTypename",
    value: function getTypename() {
      return (0, _utils.capitalizeFirstLetter)(pluralize.singular(this.relationTo()));
    }
  }, {
    key: "getChild",
    value: function getChild(fieldName) {
      if (!this.relationSchema || !this.relationSchema.items || !this.relationSchema.items.items || !this.relationSchema.items.items[fieldName]) {
        return new _nullField.default({
          key: fieldName
        });
      }

      var field = (0, _utils.createField)(fieldName, this.rootSchema, this.relationSchema.items.items[fieldName]);
      return field;
    }
  }, {
    key: "forEach",
    value: function forEach(visitor) {
      var _this = this;

      if (!this.relationSchema || !this.relationSchema.items || !this.relationSchema.items.items) {
        return;
      }

      (0, _forEach2.default)(this.relationSchema.items.items, function (item, key) {
        var field = (0, _utils.createField)(key, _this.rootSchema, _this.relationSchema.items.items[key]);
        visitor(field);
      });
    }
  }]);

  return RelationField;
}();

exports.default = RelationField;